/* A Bison parser, made by GNU Bison 2.4.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006,
   2009, 2010 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 23 "vhd2vl.y"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <assert.h>
#include "def.h"

int yylex(void);
void yyerror(char *s);

/* You will of course want to tinker with this if you use a debugging
 * malloc(), otherwise all the line numbers will point here.
 */
void *xmalloc(size_t size) {
	void *p = malloc(size);
	if (!p) {
		perror("malloc");
		exit(2);
	}
	return p;
}

int skipRem = 0;
int lineno=1;

sglist *io_list=NULL;
sglist *sig_list=NULL;
sglist *type_list=NULL;

/* need a stack of clock-edges because all edges are processed before all processes are processed.
 * Edges are processed in source file order, processes are processed in reverse source file order.
 * The original scheme of just one clkedge variable makes all clocked processes have the edge sensitivity 
 * of the last clocked process in the file.
 */
int clkedges[MAXEDGES];
int clkptr = 0;
int delay=1;
int dolist=1;
int np=1;
char wire[]="wire";
char reg[]="reg";
int dowith=0;
slist *slwith;

/* Indentation variables */
int indent=0;
slist *indents[MAXINDENT];

struct vrange *new_vrange(enum vrangeType t)
{
  struct vrange *v=xmalloc(sizeof(vrange));
  v->vtype=t;
  v->nlo = NULL;
  v->nhi = NULL;
  v->size_expr = NULL;
  v->sizeval = 0;
  v->xlo = NULL;
  v->xhi = NULL;
  return v;
}

void fslprint(FILE *fp,slist *sl){
  if(sl){
    assert(sl != sl->slst);
    fslprint(fp,sl->slst);
    switch(sl->type){
    case 0 :
      assert(sl != sl->data.sl);
      fslprint(fp,sl->data.sl);
      break;
    case 1 : case 4 :
      fprintf(fp,"%s",sl->data.txt);
      break;
    case 2 :
      fprintf(fp,"%d",sl->data.val);
      break;
    case 3 :
      fprintf(fp,"%s",*(sl->data.ptxt));
      break;
    }
  }
}

void slprint(slist *sl){
  fslprint(stdout, sl);
}

slist *copysl(slist *sl){
  if(sl){
    slist *newsl;
    newsl = xmalloc(sizeof(slist));
    *newsl = *sl;
    if (sl->slst != NULL) {
      assert(sl != sl->slst);
      newsl->slst = copysl(sl->slst);
    }
    switch(sl->type){
    case 0 :
      if (sl->data.sl != NULL) {
        assert(sl != sl->data.sl);
        newsl->data.sl = copysl(sl->data.sl);
      }
      break;
    case 1 : case 4 :
      newsl->data.txt = xmalloc(strlen(sl->data.txt) + 1);
      strcpy(newsl->data.txt, sl->data.txt);
      break;
    }
    return newsl;
  }
  return NULL;
}

slist *addtxt(slist *sl, char *s){
  slist *p;

  if(s == NULL)
    return sl;
  p = xmalloc(sizeof *p);
  p->type = 1;
  p->slst = sl;
  p->data.txt = xmalloc(strlen(s) + 1);
  strcpy(p->data.txt, s);

  return p;
}

slist *addothers(slist *sl, char *s){
  slist *p;

  if(s == NULL)
    return sl;
  p = xmalloc(sizeof *p);
  p->type = 4;
  p->slst = sl;
  p->data.txt = xmalloc(strlen(s) + 1);
  strcpy(p->data.txt, s);

  return p;
}

slist *addptxt(slist *sl, char **s){
  slist *p;

  if(s == NULL)
    return sl;

  p = xmalloc(sizeof *p);
  p->type = 3;
  p->slst = sl;
  p->data.ptxt = s;

  return p;
}

slist *addval(slist *sl, int val){
  slist *p;

  p = xmalloc(sizeof(slist));
  p->type = 2;
  p->slst = sl;
  p->data.val = val;

  return p;
}

slist *addsl(slist *sl, slist *sl2){
  slist *p;
  if(sl2 == NULL) return sl;
  p = xmalloc(sizeof(slist));
  p->type = 0;
  p->slst = sl;
  p->data.sl = sl2;
  return p;
}

slist *addvec(slist *sl, char *s){
  sl=addval(sl,strlen(s));
  sl=addtxt(sl,"'b ");
  sl=addtxt(sl,s);
  return sl;
}

slist *addvec_base(slist *sl, char *b, char *s){
  char *base_str="'b ";
  int base_mult=1;
  if (strcasecmp(b,"X") == 0) {
     base_str="'h "; base_mult=4;
  } else if (strcasecmp(b,"O") == 0) {
     base_str="'o "; base_mult=3;
  } else {
     fprintf(stderr,"Warning on line %d: NAME STRING rule matched but "
       "NAME='%s' is not X or O.\n",lineno, b);
  }
  sl=addval(sl,strlen(s)*base_mult);
  sl=addtxt(sl,base_str);
  sl=addtxt(sl,s);
  return sl;
}

slist *addind(slist *sl){
  if(sl)
    sl=addsl(indents[indent],sl);
  return sl;
}

slist *addpar(slist *sl, vrange *v){
  if(v->nlo != NULL) {   /* indexes are simple expressions */
    sl=addtxt(sl," [");
    if(v->nhi != NULL){
      sl=addsl(sl,v->nhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v->nlo);
    sl=addtxt(sl,"] ");
  } else {
    sl=addtxt(sl," ");
  }
  return sl;
}

slist *addpar_snug(slist *sl, vrange *v){
  if(v->nlo != NULL) {   /* indexes are simple expressions */
    sl=addtxt(sl,"[");
    if(v->nhi != NULL){
      sl=addsl(sl,v->nhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v->nlo);
    sl=addtxt(sl,"]");
  }
  return sl;
}

slist *addpost(slist *sl, vrange *v){
  if(v->xlo != NULL) {
    sl=addtxt(sl,"[");
    if(v->xhi != NULL){
      sl=addsl(sl,v->xhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v->xlo);
    sl=addtxt(sl,"]");
  }
  return sl;
}

slist *addwrap(char *l,slist *sl,char *r){
slist *s;
  s=addtxt(NULL,l);
  s=addsl(s,sl);
  return addtxt(s,r);
}

expdata *addnest(struct expdata *inner)
{
  expdata *e;
  e=xmalloc(sizeof(expdata));
  if (inner->op == 'c') {
    e->sl=addwrap("{",inner->sl,"}");
  } else {
    e->sl=addwrap("(",inner->sl,")"); 
  }
  return e;
}

slist *addrem(slist *sl, slist *rem)
{
  if (rem) {
    sl=addtxt(sl, "  ");
    sl=addsl(sl, rem);
  } else {
    sl=addtxt(sl, "\n");
  }
  return sl;
}

sglist *lookup(sglist *sg,char *s){
  for(;;){
    if(sg == NULL || strcmp(sg->name,s)==0)
      return sg;
    sg=sg->next;
  }
}

char *sbottom(slist *sl){
  while(sl->slst != NULL)
    sl=sl->slst;
  return sl->data.txt;
}

char *inout_string(int type)
{
  char *name=NULL;
  switch(type) {
    case 0: name="input"  ; break;
    case 1: name="output" ; break;
    case 2: name="inout"  ; break;
    default: break;
  }
  return name;
}

int prec(char op){
  switch(op){
  case 'o': /* others */
    return 9;
    break;
  case 't':case 'n':
    return 8;
    break;
  case '~':
    return 7;
    break;
  case 'p': case 'm':
    return 6;
    break;
  case '*': case '/': case '%':
    return 5;
    break;
  case '+': case '-':
    return 4;
    break;
  case '&':
    return 3;
    break;
  case '^':
    return 2;
    break;
  case '|':
    return 1;
    break;
   default:
    return 0;
    break;
  }
}

expdata *addexpr(expdata *expr1,char op,char* opstr,expdata *expr2){
slist *sl1,*sl2;
  if(expr1 == NULL)
    sl1=NULL;
  else if(expr1->op == 'c')
    sl1=addwrap("{",expr1->sl,"}");
  else if(prec(expr1->op) < prec(op))
    sl1=addwrap("(",expr1->sl,")");
  else
    sl1=expr1->sl;

  if(expr2->op == 'c')
    sl2=addwrap("{",expr2->sl,"}");
  else if(prec(expr2->op) < prec(op))
    sl2=addwrap("(",expr2->sl,")");
  else
    sl2=expr2->sl;

  if(expr1 == NULL)
    expr1=expr2;
  else
    free(expr2);

  expr1->op=op;
  sl1=addtxt(sl1,opstr);
  sl1=addsl(sl1,sl2);
  expr1->sl=sl1;
  return expr1;
}

void slTxtReplace(slist *sl, char *match, char *replace){
  if(sl){
    slTxtReplace(sl->slst, match, replace);
    switch(sl->type) {
    case 0 :
      slTxtReplace(sl->data.sl, match, replace);
      break;
    case 1 :
      if (strcmp(sl->data.txt, match) == 0) {
        sl->data.txt = replace;
      }
      break;
    case 3 :
      if (strcmp(*(sl->data.ptxt), match) == 0) {
        *(sl->data.ptxt) = replace;
      }
      break;
    }
  }
}

/* XXX maybe it's a bug that some uses don't munge clocks? */
slist *add_always(slist *sl, slist *sensitivities, slist *decls, int munge)
{
           int clkedge;
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"always @(");
           if (munge) {
             clkedge = clkedges[--clkptr];
             if(clkedge) {
               sl=addtxt(sl,"posedge ");
               /* traverse $4->sl replacing " or " with " or posedge " if there is a clockedge */
               slTxtReplace(sensitivities," or ", " or posedge ");
             } else {
               sl=addtxt(sl,"negedge ");
               slTxtReplace(sensitivities," or ", " or negedge ");
             }
           }
           sl=addsl(sl,sensitivities);
           sl=addtxt(sl,") begin");
           if(decls){
             sl=addtxt(sl," : P");
             sl=addval(sl,np++);
             sl=addtxt(sl,"\n");
             sl=addsl(sl,decls);
           }
           sl=addtxt(sl,"\n");
           return sl;
}

void fixothers(slist *size_expr, slist *sl) {
  if(sl) {
    fixothers(size_expr, sl->slst);
    switch(sl->type) {
    case 0 :
      fixothers(size_expr,sl->data.sl);
      break;
    case 4 : {
      /* found an (OTHERS => 'x') clause - change to type 0, and insert the
       * size_expr for the corresponding signal */
      slist *p;
      slist *size_copy = xmalloc(sizeof(slist));
      size_copy = copysl(size_expr);
      p = addtxt(NULL, "1'b");
      p = addtxt(p, sl->data.txt);
      p = addwrap("{",p,"}");
      p = addsl(size_copy, p);
      p = addwrap("{",p,"}");
      sl->type=0;
      sl->slst=p;
      sl->data.sl=NULL;
      break;
    } /* case 4 */
    } /* switch */
  }
}

void findothers(slval *sgin,slist *sl){
  sglist *sg = NULL;
  int size = -1;
  int useExpr=0;
  if(sgin->val>0) {
    size=sgin->val;
  } else if (sgin->range != NULL) {
    if (sgin->range->vtype != tVRANGE) {
      size=1;
    } else if (sgin->range->sizeval > 0) {
      size=sgin->range->sizeval;
    } else if (sgin->range->size_expr != NULL) {
      useExpr = 1;
      fixothers(sgin->range->size_expr, sl);
    }
  } else {
    if((sg=lookup(io_list,sgin->sl->data.txt))==NULL) {
      sg=lookup(sig_list,sgin->sl->data.txt);
    }
    if(sg) {
      if(sg->range->vtype != tVRANGE) {
        size=1;
      } else {
        if (sg->range->sizeval > 0) {
          size = sg->range->sizeval;
        } else {
          assert (sg->range->size_expr != NULL);
          useExpr = 1;
          fixothers(sg->range->size_expr, sl);
        }
      }
    } else {
      /* lookup failed, there was no vrange or size value in sgin - so just punt, and assign size=1 */
      size=1;
    }  /* if(sg) */
  }
  if (!useExpr) {
    assert(size>0);
    /* use size */
    slist *p;
    p = addval(NULL,size);
    fixothers(p,sl);
  }
}

/* code to find bit number of the msb of n */
int find_msb(int n)
{
    int k=0;
    if(n&0xff00){
        k|=8;
        n&=0xff00;
    }
    if(n&0xf0f0){
        k|=4;
        n&=0xf0f0;
    }
    if(n&0xcccc){
        k|=2;
        n&=0xcccc;
    }
    if(n&0xaaaa){
        k|=1;
        n&=0xaaaa;
    }
    return k;
}

static char time_unit[2]="\0\0", new_unit[2]="\0\0";
static void set_timescale(const char *s)
{
    if (0) fprintf(stderr,"set_timescale (%s)\n", s);
    new_unit[0] = time_unit[0];
         if (strcasecmp(s,"ms") == 0) { new_unit[0] = 'm'; }
    else if (strcasecmp(s,"us") == 0) { new_unit[0] = 'u'; }
    else if (strcasecmp(s,"ns") == 0) { new_unit[0] = 'n'; }
    else if (strcasecmp(s,"ps") == 0) { new_unit[0] = 'p'; }
    else {
        fprintf(stderr,"Warning on line %d: AFTER NATURAL NAME pattern"
               " matched, but NAME='%s' should be a time unit.\n",lineno,s);
    }
    if (new_unit[0] != time_unit[0]) {
        if (time_unit[0] != 0) {
            fprintf(stderr,"Warning on line %d: inconsistent time unit (%s) ignored\n", lineno, s);
        } else {
            time_unit[0] = new_unit[0];
        }
    }
}

slist *output_timescale(slist *sl)
{
    if (time_unit[0] != 0) {
        sl = addtxt(sl, "`timescale 1 ");
        sl = addtxt(sl, time_unit);
        sl = addtxt(sl, "s / 1 ");
        sl = addtxt(sl, time_unit);
        sl = addtxt(sl, "s\n");
    } else {
        sl = addtxt(sl, "// no timescale needed\n");
    }
    return sl;
}

slist *setup_port(sglist *s_list, int dir, vrange *type) {
  slist *sl;
  sglist *p;
  sl=addtxt(NULL,inout_string(dir));
  sl=addpar(sl,type);
  p=s_list;
  for(;;){
    p->type=wire;
    p->range=type;
    sl=addtxt(sl,p->name);
    if(p->next==NULL)
      break;
    p=p->next;
    sl=addtxt(sl,", ");
  }
  sl=addtxt(sl,";\n");
  p->next=io_list;
  io_list=s_list;
  return sl;
}


/* Line 189 of yacc.c  */
#line 645 "vhd2vl.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     REM = 258,
     ENTITY = 259,
     IS = 260,
     PORT = 261,
     GENERIC = 262,
     IN = 263,
     OUT = 264,
     INOUT = 265,
     MAP = 266,
     INTEGER = 267,
     BIT = 268,
     BITVECT = 269,
     DOWNTO = 270,
     TO = 271,
     TYPE = 272,
     END = 273,
     ARCHITECTURE = 274,
     COMPONENT = 275,
     OF = 276,
     ARRAY = 277,
     SIGNAL = 278,
     BEGN = 279,
     NOT = 280,
     WHEN = 281,
     WITH = 282,
     EXIT = 283,
     SELECT = 284,
     OTHERS = 285,
     PROCESS = 286,
     VARIABLE = 287,
     CONSTANT = 288,
     IF = 289,
     THEN = 290,
     ELSIF = 291,
     ELSE = 292,
     CASE = 293,
     FOR = 294,
     LOOP = 295,
     GENERATE = 296,
     AFTER = 297,
     AND = 298,
     OR = 299,
     XOR = 300,
     MOD = 301,
     LASTVALUE = 302,
     EVENT = 303,
     POSEDGE = 304,
     NEGEDGE = 305,
     STRING = 306,
     NAME = 307,
     RANGE = 308,
     NULLV = 309,
     OPEN = 310,
     CONVFUNC_1 = 311,
     CONVFUNC_2 = 312,
     BASED = 313,
     NATURAL = 314,
     ORL = 315,
     ANDL = 316,
     XNOR = 317,
     EQUAL = 318,
     NOTEQ = 319,
     LESSEQ = 320,
     BIGEQ = 321,
     NOTL = 322,
     UPLUS = 323,
     UMINUS = 324
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 595 "vhd2vl.y"

  char * txt; /* String */
  int n;      /* Value */
  vrange *v;  /* Signal range */
  sglist *sg; /* Signal list */
  slist *sl;  /* String list */
  expdata *e; /* Expression structure */
  slval *ss;  /* Signal structure */



/* Line 214 of yacc.c  */
#line 762 "vhd2vl.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 774 "vhd2vl.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1078

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  85
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  51
/* YYNRULES -- Number of rules.  */
#define YYNRULES  169
/* YYNRULES -- Number of states.  */
#define YYNSTATES  616

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   324

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    72,    82,
      78,    79,    73,    70,    83,    71,     2,    74,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    81,    80,
      64,    60,    65,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    84,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    61,    62,    63,    66,    67,
      68,    69,    75,    76,    77
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     9,    13,    17,    18,    20,    22,    25,
      26,    28,    29,    31,    32,    34,    35,    36,    51,    75,
      83,    93,   100,   105,   111,   119,   128,   139,   141,   143,
     145,   147,   153,   155,   160,   162,   166,   168,   172,   174,
     176,   192,   193,   194,   195,   203,   214,   224,   237,   258,
     259,   268,   269,   270,   273,   278,   280,   290,   302,   318,
     340,   357,   381,   413,   449,   462,   479,   496,   497,   499,
     501,   505,   509,   515,   521,   526,   531,   532,   535,   540,
     546,   551,   553,   561,   572,   574,   584,   593,   606,   622,
     638,   649,   654,   659,   660,   668,   673,   682,   690,   691,
     693,   697,   699,   702,   704,   706,   710,   714,   720,   728,
     729,   730,   734,   737,   742,   744,   749,   751,   753,   755,
     758,   760,   763,   768,   771,   776,   778,   783,   785,   787,
     789,   792,   795,   802,   806,   809,   812,   816,   820,   824,
     828,   832,   835,   839,   843,   847,   851,   856,   863,   870,
     874,   876,   880,   884,   888,   891,   895,   899,   904,   908,
     913,   918,   920,   922,   924,   928,   932,   936,   940,   945
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      86,     0,    -1,    87,    94,    87,   101,    87,    -1,    87,
      94,    87,    -1,    87,   101,    87,    -1,    -1,    88,    -1,
       3,    -1,     3,    88,    -1,    -1,     5,    -1,    -1,     4,
      -1,    -1,    19,    -1,    -1,    -1,     4,    52,     5,     6,
      78,    87,    96,    79,    80,    87,    18,    90,   110,    80,
      -1,     4,    52,     5,     7,   107,    78,    87,    95,    79,
      80,    87,     6,   107,    78,    87,    96,    79,    80,    87,
      18,    90,   110,    80,    -1,   108,    81,    98,    81,    60,
     132,    87,    -1,   108,    81,    98,    81,    60,   132,    80,
      87,    95,    -1,   108,    81,    98,    80,    87,    95,    -1,
     108,    81,    98,    87,    -1,   108,    81,    97,    98,    87,
      -1,   108,    81,    97,    98,    80,    87,    96,    -1,   108,
      81,    97,    98,    81,    60,   132,    87,    -1,   108,    81,
      97,    98,    81,    60,   132,    80,    87,    96,    -1,     8,
      -1,     9,    -1,    10,    -1,    13,    -1,    12,    53,   132,
      16,   132,    -1,    12,    -1,    14,    78,    99,    79,    -1,
      52,    -1,   135,   100,   135,    -1,   135,    -1,    52,    82,
      53,    -1,    15,    -1,    16,    -1,    19,    52,    21,    52,
       5,    87,   104,    24,   102,   109,    18,    91,   110,    80,
     103,    -1,    -1,    -1,    -1,   104,    23,   108,    81,    98,
      80,    87,    -1,   104,    33,    52,    81,    98,    81,    60,
     132,    80,    87,    -1,   104,    17,    52,     5,    78,   108,
      79,    80,    87,    -1,   104,    17,    52,     5,    22,    78,
      99,    79,    21,    98,    80,    87,    -1,   104,    20,    52,
      89,    87,   105,     6,   106,    78,    87,    96,    79,    80,
      87,    18,    20,   110,    80,   107,    87,    -1,    -1,     7,
     106,    78,    87,    95,    79,    80,    87,    -1,    -1,    -1,
      52,    87,    -1,    52,    83,    87,   108,    -1,    87,    -1,
      87,   131,    64,    60,    87,    92,   123,    93,   109,    -1,
      87,    27,   132,    29,    87,   113,   131,    64,    60,   114,
     109,    -1,    87,    52,    81,    52,    87,     6,    11,    78,
     102,   126,    87,    79,    80,   103,   109,    -1,    87,    52,
      81,    52,    87,     7,    11,    78,   102,   129,    79,   103,
       6,    11,    78,   102,   126,    79,    80,   103,   109,    -1,
     111,    31,    78,   122,    79,   116,    89,    24,   102,   117,
      18,    31,   110,    80,   103,   109,    -1,   111,    31,    78,
     122,    79,   116,    89,    24,   102,    87,    34,   112,    35,
     117,    18,    34,    80,    18,    31,   110,    80,   103,   109,
      -1,   111,    31,    78,   122,    79,   116,    89,    24,   102,
      87,    34,   133,    35,   102,   117,   103,    36,   112,    35,
     102,   117,   103,    18,    34,    80,    18,    31,   110,    80,
     103,   109,    -1,   111,    31,    78,   122,    79,   116,    89,
      24,   102,    87,    34,   133,    35,   102,   117,   103,    37,
      34,   112,    35,   102,   117,   103,    18,    34,    80,    18,
      34,    80,    18,    31,   110,    80,   103,   109,    -1,   111,
      34,   133,    41,   102,   109,   103,    18,    41,   110,    80,
     109,    -1,   111,    39,   131,     8,   132,    16,   132,    41,
     102,   109,   103,    18,    41,   110,    80,   109,    -1,   111,
      39,   131,     8,   132,    15,   132,    41,   102,   109,   103,
      18,    41,   110,    80,   109,    -1,    -1,    52,    -1,    87,
      -1,    87,    52,    81,    -1,    78,   112,    79,    -1,    52,
      82,    48,    43,   133,    -1,   133,    43,    52,    82,    48,
      -1,    49,    78,    52,    79,    -1,    50,    78,    52,    79,
      -1,    -1,   115,    80,    -1,   115,    83,    87,   114,    -1,
     132,   125,    26,    30,    80,    -1,   132,   125,    26,   120,
      -1,    87,    -1,    87,    32,   108,    81,    98,    80,   116,
      -1,    87,    32,   108,    81,    98,    81,    60,   132,    80,
     116,    -1,    87,    -1,    87,   131,    81,    60,    92,   132,
      80,    93,   117,    -1,    87,   131,    92,    64,    60,   123,
      93,   117,    -1,    87,    34,   133,    35,   102,   117,   103,
     118,    18,    34,    80,   117,    -1,    87,    39,   131,     8,
     132,    16,   132,    40,   102,   117,   103,    18,    40,    80,
     117,    -1,    87,    39,   131,     8,   132,    15,   132,    40,
     102,   117,   103,    18,    40,    80,   117,    -1,    87,    38,
     131,     5,    87,   119,    18,    38,    80,   117,    -1,    87,
      28,    80,   117,    -1,    87,    54,    80,   117,    -1,    -1,
      36,   133,    35,   102,   117,   103,   118,    -1,    37,   102,
     117,   103,    -1,    26,   120,    60,    65,   102,   117,   103,
     119,    -1,    26,    30,    60,    65,   102,   117,   103,    -1,
      -1,   121,    -1,   120,    84,   121,    -1,    51,    -1,    52,
      51,    -1,    52,    -1,   131,    -1,   131,    83,   122,    -1,
     132,   125,    80,    -1,   132,   125,    26,   133,    80,    -1,
     132,   125,    26,   133,    37,   124,   123,    -1,    -1,    -1,
      42,    59,    52,    -1,    87,   127,    -1,    87,   127,    83,
     126,    -1,   128,    -1,    52,    60,    65,   128,    -1,    51,
      -1,   131,    -1,    59,    -1,    52,    51,    -1,    55,    -1,
      87,   130,    -1,    87,   130,    83,   129,    -1,    87,   132,
      -1,    52,    60,    65,   132,    -1,    52,    -1,    52,    78,
      99,    79,    -1,   131,    -1,    51,    -1,    59,    -1,    59,
      58,    -1,    52,    51,    -1,    78,    30,    60,    65,    51,
      79,    -1,   132,    72,   132,    -1,    71,   132,    -1,    70,
     132,    -1,   132,    70,   132,    -1,   132,    71,   132,    -1,
     132,    73,   132,    -1,   132,    74,   132,    -1,   132,    46,
     132,    -1,    25,   132,    -1,   132,    43,   132,    -1,   132,
      44,   132,    -1,   132,    45,   132,    -1,   132,    63,   132,
      -1,    14,    78,   132,    79,    -1,    57,    78,   132,    83,
      59,    79,    -1,    57,    78,   132,    83,    52,    79,    -1,
      78,   132,    79,    -1,   134,    -1,    78,   133,    79,    -1,
     133,    43,   133,    -1,   133,    44,   133,    -1,    25,   133,
      -1,   132,    60,   132,    -1,   132,    65,   132,    -1,   132,
      65,    60,   132,    -1,   132,    64,   132,    -1,   132,    64,
      60,   132,    -1,   132,    74,    60,   132,    -1,   131,    -1,
      51,    -1,    59,    -1,   135,    70,   135,    -1,   135,    71,
     135,    -1,   135,    73,   135,    -1,   135,    74,   135,    -1,
      56,    78,   135,    79,    -1,    78,   135,    79,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   666,   666,   681,   689,   700,   701,   704,   705,   711,
     711,   713,   713,   715,   715,   718,   719,   723,   760,   802,
     823,   845,   865,   886,   899,   912,   926,   941,   942,   943,
     946,   949,   955,   960,   961,   975,  1013,  1017,  1032,  1033,
    1037,  1047,  1050,  1053,  1054,  1082,  1091,  1131,  1144,  1152,
    1153,  1161,  1162,  1165,  1178,  1193,  1195,  1208,  1236,  1249,
    1269,  1278,  1293,  1320,  1349,  1365,  1395,  1419,  1420,  1423,
    1424,  1427,  1428,  1432,  1437,  1441,  1447,  1449,  1450,  1458,
    1477,  1498,  1499,  1519,  1543,  1545,  1559,  1578,  1591,  1613,
    1635,  1650,  1656,  1666,  1667,  1677,  1686,  1695,  1702,  1705,
    1706,  1713,  1714,  1715,  1718,  1719,  1727,  1743,  1747,  1760,
    1763,  1764,  1770,  1774,  1783,  1784,  1794,  1795,  1796,  1797,
    1798,  1802,  1806,  1813,  1818,  1828,  1842,  1864,  1872,  1879,
    1885,  1910,  1916,  1923,  1932,  1933,  1934,  1935,  1936,  1937,
    1938,  1939,  1940,  1941,  1942,  1943,  1944,  1955,  1959,  1962,
    1968,  1969,  1972,  1977,  1982,  1990,  2007,  2024,  2041,  2058,
    2075,  2094,  2102,  2109,  2117,  2120,  2123,  2126,  2129,  2136
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "REM", "ENTITY", "IS", "PORT", "GENERIC",
  "IN", "OUT", "INOUT", "MAP", "INTEGER", "BIT", "BITVECT", "DOWNTO", "TO",
  "TYPE", "END", "ARCHITECTURE", "COMPONENT", "OF", "ARRAY", "SIGNAL",
  "BEGN", "NOT", "WHEN", "WITH", "EXIT", "SELECT", "OTHERS", "PROCESS",
  "VARIABLE", "CONSTANT", "IF", "THEN", "ELSIF", "ELSE", "CASE", "FOR",
  "LOOP", "GENERATE", "AFTER", "AND", "OR", "XOR", "MOD", "LASTVALUE",
  "EVENT", "POSEDGE", "NEGEDGE", "STRING", "NAME", "RANGE", "NULLV",
  "OPEN", "CONVFUNC_1", "CONVFUNC_2", "BASED", "NATURAL", "'='", "ORL",
  "ANDL", "XNOR", "'<'", "'>'", "EQUAL", "NOTEQ", "LESSEQ", "BIGEQ", "'+'",
  "'-'", "'&'", "'*'", "'/'", "NOTL", "UPLUS", "UMINUS", "'('", "')'",
  "';'", "':'", "'\\''", "','", "'|'", "$accept", "trad", "rem", "remlist",
  "opt_is", "opt_entity", "opt_architecture", "norem", "yesrem", "entity",
  "genlist", "portlist", "dir", "type", "vec_range", "updown",
  "architecture", "doindent", "unindent", "a_decl", "opt_generic",
  "nolist", "yeslist", "s_list", "a_body", "oname", "optname", "edge",
  "yeswith", "with_list", "with_item", "p_decl", "p_body", "elsepart",
  "cases", "wlist", "wvalue", "sign_list", "sigvalue", "nodelay", "delay",
  "map_list", "map_item", "mvalue", "generic_map_list", "generic_map_item",
  "signal", "expr", "exprc", "conf", "simple_expr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
      61,   315,   316,   317,    60,    62,   318,   319,   320,   321,
      43,    45,    38,    42,    47,   322,   323,   324,    40,    41,
      59,    58,    39,    44,   124
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    85,    86,    86,    86,    87,    87,    88,    88,    89,
      89,    90,    90,    91,    91,    92,    93,    94,    94,    95,
      95,    95,    95,    96,    96,    96,    96,    97,    97,    97,
      98,    98,    98,    98,    98,    99,    99,    99,   100,   100,
     101,   102,   103,   104,   104,   104,   104,   104,   104,   105,
     105,   106,   107,   108,   108,   109,   109,   109,   109,   109,
     109,   109,   109,   109,   109,   109,   109,   110,   110,   111,
     111,   112,   112,   112,   112,   112,   113,   114,   114,   114,
     115,   116,   116,   116,   117,   117,   117,   117,   117,   117,
     117,   117,   117,   118,   118,   118,   119,   119,   119,   120,
     120,   121,   121,   121,   122,   122,   123,   123,   123,   124,
     125,   125,   126,   126,   127,   127,   128,   128,   128,   128,
     128,   129,   129,   129,   130,   131,   131,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
     133,   133,   133,   133,   133,   134,   134,   134,   134,   134,
     134,   135,   135,   135,   135,   135,   135,   135,   135,   135
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     5,     3,     3,     0,     1,     1,     2,     0,
       1,     0,     1,     0,     1,     0,     0,    14,    23,     7,
       9,     6,     4,     5,     7,     8,    10,     1,     1,     1,
       1,     5,     1,     4,     1,     3,     1,     3,     1,     1,
      15,     0,     0,     0,     7,    10,     9,    12,    20,     0,
       8,     0,     0,     2,     4,     1,     9,    11,    15,    21,
      16,    23,    31,    35,    12,    16,    16,     0,     1,     1,
       3,     3,     5,     5,     4,     4,     0,     2,     4,     5,
       4,     1,     7,    10,     1,     9,     8,    12,    15,    15,
      10,     4,     4,     0,     7,     4,     8,     7,     0,     1,
       3,     1,     2,     1,     1,     3,     3,     5,     7,     0,
       0,     3,     2,     4,     1,     4,     1,     1,     1,     2,
       1,     2,     4,     2,     4,     1,     4,     1,     1,     1,
       2,     2,     6,     3,     2,     2,     3,     3,     3,     3,
       3,     2,     3,     3,     3,     3,     4,     6,     6,     3,
       1,     3,     3,     3,     2,     3,     3,     4,     3,     4,
       4,     1,     1,     1,     3,     3,     3,     3,     4,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       5,     7,     0,     0,     6,     8,     1,     0,     0,     5,
       5,     0,     0,     3,     4,     0,     0,     5,     0,    52,
       0,     2,     5,     0,     5,     0,     5,    43,     5,     0,
       0,     0,     0,     5,    53,     0,     0,     0,     0,     0,
       0,     0,    41,     0,     0,     5,    27,    28,    29,     0,
       0,     0,     0,     9,     0,     5,     0,    54,     0,    32,
      30,     0,    34,     5,     5,     5,     0,    10,     5,     0,
      69,     0,     0,     0,    11,     0,     0,     5,     0,    23,
       0,     5,     0,    22,     0,     0,    49,     0,     0,   125,
       0,    13,     0,     0,     0,     0,    12,    67,     0,     0,
     128,   125,     0,   129,     0,     0,     0,   127,     0,   162,
     125,     0,   163,     0,     0,   161,    36,     0,     0,    52,
       0,     0,     0,     0,    51,     0,     5,     0,     0,    70,
       0,    14,    67,     0,     0,     0,     0,     0,   150,   125,
       0,     0,    68,     0,     0,   141,   131,     0,   130,   135,
     134,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    33,    38,    39,
       0,     0,     0,     0,     0,    24,     5,     0,    21,     5,
       0,     0,     0,    51,    44,     5,     0,     5,     5,     0,
       0,   104,   141,   154,     0,     0,     0,     0,     0,     0,
      41,     0,     0,     0,     0,    17,     0,     0,     0,   149,
      31,   142,   143,   144,   140,   145,   136,   137,   133,   138,
     139,    37,     0,   169,   164,   165,   166,   167,    35,     5,
      25,     5,     5,    19,     0,     5,     5,     0,    76,   126,
       0,    15,    42,     5,     0,   151,   155,     0,   158,     0,
     156,     0,     5,   152,   153,     0,     0,   146,     0,     0,
     168,     0,     0,     0,     0,    46,     0,     5,     0,     0,
       0,     0,    40,    81,     9,   105,   159,   157,   160,    42,
       0,     0,     5,     0,     0,     0,    26,     0,    20,     0,
       0,     0,     0,     0,     0,    16,   110,     0,     0,     0,
       0,     0,    45,   148,   147,   132,     0,     5,     0,     0,
       0,    41,    41,     5,     0,     0,     0,    41,     0,    41,
      41,     5,    47,     5,     0,     0,     5,     5,    56,     0,
       0,   106,     0,     5,    67,     5,     5,     0,    50,     5,
       5,     0,   110,     0,     5,     0,     0,   111,     0,     0,
      84,     0,     0,    42,    42,    11,     0,    57,    77,     5,
       0,   116,   125,   120,   118,   112,   114,   117,     0,   125,
     121,   123,    42,   109,   107,     5,     0,     0,     0,     0,
       0,     0,    15,     0,     5,     0,     0,    67,     0,     0,
       0,   119,     0,     5,     0,     0,     5,     0,     0,    82,
       0,     5,     0,     0,   125,     0,     0,     0,     0,     0,
       5,     0,     0,    67,    64,     0,     0,     0,    67,    78,
       0,   101,   103,    80,    99,     0,   113,    42,     0,   122,
       0,   108,     0,    84,    91,     0,     0,     0,     0,     0,
       5,    41,     0,     5,     0,    92,    15,     0,     0,    67,
      67,    18,     0,    79,   102,     0,   125,   115,     5,   124,
       0,     5,     0,     0,     0,     0,    71,     0,     5,   125,
      98,     0,     0,     0,    42,     0,     0,    52,   100,    58,
      41,    83,     0,    74,    75,     0,     0,    42,     0,     0,
       0,     0,     0,     0,    16,     5,     5,     5,     5,     5,
      41,    72,     0,    93,    73,     0,     0,     0,     0,     0,
      16,     5,    60,    66,    65,    48,     0,     5,     0,     0,
      41,     0,     0,     0,     0,    41,    41,     5,    86,     0,
      42,     0,     0,     0,     0,     5,     0,    41,    41,     5,
       5,     5,    85,    42,    93,    67,    41,    41,     0,     0,
      42,     0,     5,     5,    90,    42,    42,     5,     0,    41,
       0,     5,     5,    41,    95,     5,    42,    42,     0,     0,
      59,     0,    42,    42,    42,     5,    87,    97,    98,     0,
       0,     5,     0,    93,    42,    96,     0,     0,    61,     0,
      94,     0,     5,     5,     0,     0,    89,    88,     0,     0,
       0,     0,    67,     0,     0,     0,    42,     0,     5,     0,
      62,    67,     0,    42,     5,    63
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,   433,     4,    68,    97,   132,   271,   313,     9,
      37,    29,    49,    63,   114,   174,    10,   535,   272,    32,
     125,   182,    23,    30,    71,   143,    72,   406,   268,   340,
     341,   274,   351,   521,   490,   423,   424,   190,   295,   398,
     315,   344,   365,   366,   346,   370,   107,   136,   253,   138,
     116
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -454
static const yytype_int16 yypact[] =
{
      73,    73,    85,    63,  -454,  -454,  -454,    35,    68,    73,
      73,   139,   107,   159,  -454,   155,    97,    73,    78,  -454,
     191,  -454,    73,   126,    73,   189,    73,  -454,     9,   170,
     172,   189,   286,    73,  -454,   179,   230,   187,   188,   222,
     228,   189,  -454,   233,   189,    73,  -454,  -454,  -454,    39,
     216,    39,   284,   299,   235,    73,   241,  -454,   290,   261,
    -454,   256,  -454,    20,    73,    22,   -18,  -454,    73,    39,
       2,   325,   129,    39,   346,   512,   199,    73,   297,  -454,
     352,    73,   310,  -454,   291,   189,   361,   293,   512,   -62,
     312,   366,   314,   575,   334,   313,  -454,   338,   322,   512,
    -454,   -17,   323,   345,   512,   512,   347,  -454,   708,  -454,
     -34,   337,  -454,   209,   342,  -454,    34,   189,   512,  -454,
     189,   512,   199,   343,  -454,   424,    73,   702,   199,   380,
     373,  -454,   338,   334,   575,   542,   998,    75,  -454,   359,
     427,   378,  -454,   360,   512,  -454,  -454,   512,  -454,  -454,
    -454,   379,   859,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   392,   209,   340,  -454,  -454,  -454,
     209,   209,   209,   209,   209,  -454,   174,   371,  -454,   308,
     383,   370,   381,  -454,  -454,    73,   393,    73,    73,   376,
     394,   374,  -454,  -454,   847,    15,   512,   545,   622,   626,
    -454,   575,   575,   512,   512,  -454,   891,   751,   402,  -454,
    1004,   227,   772,   812,   506,   154,   125,   125,   125,  -454,
    -454,  -454,   395,  -454,   137,   137,  -454,  -454,   536,    73,
    -454,    73,    73,  -454,   454,    73,    73,   405,  -454,  -454,
     250,  -454,  -454,    73,   334,  -454,   292,   512,   292,   512,
     292,   512,    73,   220,   220,   408,   756,  -454,    19,   433,
    -454,   189,   189,   189,    39,  -454,   189,    73,   334,   474,
     477,   512,  -454,   459,   299,  -454,   292,   292,   292,  -454,
     512,   512,    73,   421,   437,   440,  -454,   442,  -454,   423,
     449,   189,   465,   452,   456,  -454,   983,   189,   515,   518,
     944,   950,  -454,  -454,  -454,  -454,   472,    73,   473,   475,
     495,  -454,  -454,    73,   499,    -8,   480,  -454,   519,  -454,
    -454,    73,  -454,    73,   485,   512,    73,    73,  -454,   514,
     575,  -454,    39,    73,   338,    73,    73,   550,  -454,    73,
      73,   106,   983,   357,    73,   651,   494,  -454,    -7,   198,
     479,   556,   508,  -454,  -454,   346,   577,  -454,  -454,    73,
     572,  -454,   130,  -454,  -454,   520,  -454,  -454,   532,   143,
     534,  1004,  -454,  -454,  -454,    73,   559,   541,    72,   334,
     334,   544,   547,   591,    73,   607,   611,   338,   610,   512,
      87,  -454,   568,    73,   561,   583,    73,   636,   512,  -454,
     512,    73,   571,   574,   -16,   377,   615,   123,   652,   648,
      73,   598,   599,   338,  -454,   623,   625,   587,   338,  -454,
     590,  -454,   620,   600,  -454,   453,  -454,  -454,   512,  -454,
     664,  -454,   794,   486,  -454,   635,   637,   640,   616,    69,
      73,  -454,   666,    73,   512,  -454,  -454,   630,   618,   338,
     338,  -454,   619,  -454,  -454,   240,    -9,  -454,    73,  1004,
     627,    73,   575,   628,   641,   663,  -454,   691,    73,   102,
     688,   696,   512,   512,  -454,   639,   646,  -454,  -454,  -454,
    -454,  -454,   158,  -454,  -454,   575,   681,  -454,   668,   122,
     709,   512,   512,   826,  -454,    73,    73,    73,    73,    73,
    -454,   220,   650,   294,  -454,   672,    46,   690,   903,   938,
    -454,    73,  -454,  -454,  -454,  -454,   655,    73,   717,    72,
     704,   725,   684,   685,   675,  -454,  -454,    73,  -454,   676,
    -454,   726,   723,   251,    72,    73,   727,  -454,  -454,    73,
      73,    73,  -454,  -454,   309,   338,  -454,  -454,   728,   304,
    -454,   680,    73,    73,  -454,  -454,  -454,    73,   575,  -454,
     682,    73,    73,  -454,  -454,    73,  -454,  -454,   746,   765,
    -454,   285,  -454,  -454,  -454,    73,  -454,  -454,   688,   744,
     745,    73,   769,   309,  -454,  -454,   710,   711,  -454,   755,
    -454,   774,    73,    73,   718,   770,  -454,  -454,   785,   729,
     775,   787,   338,   773,   730,   731,  -454,   790,    73,   781,
    -454,   338,   733,  -454,    73,  -454
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -454,  -454,     0,   819,   557,   478,  -454,  -367,  -453,  -454,
    -112,  -116,  -454,   -30,   -48,  -454,   828,   -36,    88,  -454,
    -454,   665,  -117,    52,  -225,  -125,  -454,  -394,  -454,   458,
    -454,  -362,  -370,   266,   272,   362,   397,   609,  -384,  -454,
     517,  -390,  -454,   429,   460,  -454,   -38,   388,   -88,  -454,
      42
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -56
static const yytype_int16 yytable[] =
{
       3,   175,   177,   426,    84,   137,    55,   189,   178,    13,
      14,   438,     1,   399,   431,   412,   128,    21,   330,   129,
     -55,    65,    25,     1,    27,     1,    31,   279,    34,    88,
     373,   434,    90,    44,   146,   146,   201,   202,   115,    87,
     445,   511,   391,    95,   128,    58,   193,   195,   164,   168,
     169,    59,    60,    61,    89,    70,   140,   527,   201,   202,
      85,   128,   128,    79,    80,    83,   437,     7,    86,   128,
     467,   283,   331,   374,   180,   115,     1,   117,   284,   472,
     186,   120,     8,    38,   115,     6,    98,    11,   328,   494,
     115,    62,    33,    54,   245,   191,    57,   134,   487,   481,
      77,    78,    81,    82,   170,   171,   523,   172,   173,   516,
     353,   354,   442,   202,   254,   357,   200,   420,   201,   202,
      12,   402,   403,   100,   404,   532,   184,   115,    16,   102,
     455,   103,   115,   115,   115,   115,   115,   123,   421,   422,
     548,   528,   104,   105,    15,   286,   287,   530,   245,    20,
     405,   288,   505,   146,   290,   166,    22,   542,   441,   414,
      92,    18,    19,    93,   252,   550,   442,   202,    94,   554,
     555,   556,    38,   421,   422,   309,   230,     1,     8,   233,
     128,   391,   566,   567,   488,   238,   358,   240,   241,   359,
     392,   573,   574,   500,   146,   576,    24,   154,   162,   163,
     157,   201,   202,   395,    26,   584,   191,   222,   128,   352,
     172,   173,   224,   225,   226,   227,   228,   154,   155,   156,
     157,   128,   596,   597,   159,   160,   161,   162,   163,   261,
     292,   262,   263,   479,   289,   265,   266,   158,    46,    47,
      48,    28,   348,   273,   159,   160,   161,   162,   163,    35,
     109,   110,    70,    36,   229,   111,   269,   270,   112,    45,
     109,   139,   417,   201,   202,   111,    50,   291,   112,    51,
     512,   513,   514,   157,    52,   326,   327,   113,   375,   376,
      53,   333,   302,   335,   336,    56,   547,   113,   448,    66,
     407,   421,   422,   452,   442,   202,    64,   159,   160,   161,
     162,   163,   349,    39,    67,   367,    40,   322,    74,    41,
      42,     1,   382,    70,    75,    38,    69,   439,    38,    43,
     547,   337,    73,   338,   475,   476,   343,   345,   201,   202,
     519,   520,   570,   350,    76,    70,    70,   156,   157,   356,
      70,   408,   409,    91,   368,   558,   559,   442,   202,   316,
      96,   154,   155,   156,   157,   158,   588,   118,   119,   389,
     498,    98,   159,   160,   161,   162,   163,   299,   124,   122,
     121,   158,    99,   126,   482,   273,   130,   151,   159,   160,
     161,   162,   163,   610,    70,   131,   139,   367,   232,   615,
     142,    98,   133,   343,   141,   382,   345,   501,   100,   101,
     144,   147,   134,   148,   102,   468,   103,   151,   361,   362,
     170,   171,   363,   172,   173,   165,   364,   104,   105,   223,
     560,   167,   181,   280,   281,   106,   402,   403,   100,   404,
     183,   533,   187,   188,   102,   203,   103,   128,   204,   208,
     205,   385,   386,   470,   499,   221,   549,   104,   105,   231,
     235,   154,   155,   156,   157,   405,   242,   244,    70,   236,
     397,   273,   234,   108,   517,   170,   171,   259,   172,   173,
     571,   158,   239,   243,   260,   264,   127,   604,   159,   160,
     161,   162,   163,   267,   285,   293,   612,   145,   294,   540,
     541,   297,   149,   150,   152,    70,    70,    70,   515,   343,
     303,   552,   553,   307,   361,   456,   176,   377,   363,   179,
     561,   562,   364,   378,   377,   458,   304,   379,   380,   305,
     462,   306,   192,   194,   379,   380,    98,   575,   308,   310,
     311,   139,   206,   381,   312,   207,   318,    99,   139,   317,
     381,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   321,   323,   324,   325,    98,    70,   329,    98,
     334,   332,   495,   100,   101,   339,   347,   134,   355,   102,
      99,   103,   151,   372,   383,   503,   159,   160,   161,   162,
     163,    70,   104,   105,   246,   248,   250,   220,   384,    98,
     106,   255,   256,   100,   101,   388,   100,   101,   390,   102,
     134,   103,   102,   393,   103,   247,   170,   171,    70,   172,
     173,   394,   104,   105,    70,   104,   105,   396,   544,   400,
     135,   401,   413,   106,   410,   415,   100,   101,   411,   416,
     418,   557,   102,   425,   103,   276,    98,   277,   564,   278,
      98,   427,   430,   568,   569,   104,   105,    99,   428,   435,
     440,    99,   436,   135,   577,   578,   444,   443,   446,   296,
     581,   582,   583,   447,   449,    98,   450,   451,   300,   301,
     453,   454,   591,   100,   101,   460,    99,   100,   101,   102,
      98,   103,   249,   102,   455,   103,   251,   463,   465,   464,
     473,   134,   104,   105,   608,   466,   104,   105,   474,   477,
     106,   614,   100,   369,   106,   480,   485,   483,   102,   486,
     103,   491,   492,   342,   489,   502,   504,   100,   469,   496,
     484,   104,   105,   102,   153,   103,   497,   507,   524,   106,
     518,   185,   522,   371,   529,   531,   104,   105,   534,   154,
     155,   156,   157,   536,   135,   154,   155,   156,   157,   537,
     538,   154,   155,   156,   157,   539,   543,   545,   546,   158,
     565,   551,   572,   563,   579,   158,   159,   160,   161,   162,
     163,   158,   159,   160,   161,   162,   163,   342,   159,   160,
     161,   162,   163,   580,   586,   587,   296,   589,   432,   594,
     592,   593,   595,   194,   154,   155,   156,   157,   598,   154,
     155,   156,   157,   600,   599,   603,   602,   605,   609,   601,
     606,   607,   611,   613,   158,   154,   459,   156,   157,   158,
       5,   159,   160,   161,   162,   163,   159,   160,   161,   162,
     163,   298,   471,   387,   258,   158,   282,   154,   155,   156,
     157,    17,   159,   160,   161,   162,   163,   419,   237,   590,
     585,   506,   478,   275,   457,   154,   429,   158,   157,   360,
     493,   296,     0,     0,   159,   160,   161,   162,   163,   154,
     155,   156,   157,     0,   461,   158,     0,     0,     0,   508,
     509,     0,   159,   160,   161,   162,   163,     0,     0,   158,
     154,   155,   156,   157,     0,     0,   159,   160,   161,   162,
     163,     0,   154,   155,   156,   157,   510,   196,     0,     0,
     158,   197,   198,     0,     0,     0,     0,   159,   160,   161,
     162,   199,   158,     0,     0,     0,   209,     0,     0,   159,
     160,   161,   162,   163,   154,   155,   156,   157,   209,     0,
       0,     0,     0,   525,     0,     0,   154,   155,   156,   157,
       0,     0,     0,     0,   158,     0,     0,     0,     0,     0,
       0,   159,   160,   161,   162,   163,   158,     0,     0,     0,
     257,     0,     0,   159,   160,   161,   162,   163,   526,     0,
       0,   154,   155,   156,   157,   319,     0,   154,   155,   156,
     157,   320,     0,   154,   155,   156,   157,     0,     0,     0,
       0,   158,     0,     0,     0,     0,     0,   158,   159,   160,
     161,   162,   163,   158,   159,   160,   161,   162,   163,     0,
     159,   160,   161,   162,   163,   314,   154,   155,   156,   157,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   154,   155,   156,   157,     0,   158,   154,   155,   156,
     157,     0,     0,   159,   160,   161,   162,   163,   196,     0,
       0,   158,   197,   198,     0,     0,     0,   158,   159,   160,
     161,   162,   199,     0,   159,   160,   161,   162,   163
};

static const yytype_int16 yycheck[] =
{
       0,   117,   119,   393,    22,    93,    42,   132,   120,     9,
      10,   405,     3,   375,   398,   382,    78,    17,    26,    81,
      18,    51,    22,     3,    24,     3,    26,   252,    28,    27,
      37,   401,    70,    33,    51,    51,    43,    44,    76,    69,
     410,   494,    51,    73,    78,    45,   134,   135,    82,    15,
      16,    12,    13,    14,    52,    55,    94,   510,    43,    44,
      78,    78,    78,    63,    64,    65,    82,     4,    68,    78,
     440,    52,    80,    80,   122,   113,     3,    77,    59,   446,
     128,    81,    19,    31,   122,     0,    14,    52,   313,   473,
     128,    52,    83,    41,    79,   133,    44,    25,   468,   461,
      80,    81,    80,    81,    70,    71,    60,    73,    74,   499,
     335,   336,    43,    44,   202,   340,    41,    30,    43,    44,
      52,    49,    50,    51,    52,   519,   126,   165,    21,    57,
      84,    59,   170,   171,   172,   173,   174,    85,    51,    52,
     534,   511,    70,    71,     5,   261,   262,   517,    79,    52,
      78,   263,    30,    51,   266,   113,    78,   527,    35,   384,
      31,     6,     7,    34,   200,   535,    43,    44,    39,   539,
     540,   541,   120,    51,    52,   291,   176,     3,    19,   179,
      78,    51,   552,   553,    82,   185,    80,   187,   188,    83,
      60,   561,   562,    35,    51,   565,     5,    43,    73,    74,
      46,    43,    44,    60,    78,   575,   244,   165,    78,   334,
      73,    74,   170,   171,   172,   173,   174,    43,    44,    45,
      46,    78,   592,   593,    70,    71,    72,    73,    74,   229,
     268,   231,   232,   458,   264,   235,   236,    63,     8,     9,
      10,    52,   330,   243,    70,    71,    72,    73,    74,    79,
      51,    52,   252,    81,    80,    56,     6,     7,    59,    80,
      51,    52,   387,    43,    44,    56,    79,   267,    59,    81,
     495,   496,   497,    46,    52,   311,   312,    78,    80,    81,
      52,   317,   282,   319,   320,    52,    35,    78,   413,     5,
     378,    51,    52,   418,    43,    44,    80,    70,    71,    72,
      73,    74,   332,    17,     5,   343,    20,   307,    18,    23,
      24,     3,   350,   313,    53,   263,    81,   405,   266,    33,
      35,   321,    81,   323,   449,   450,   326,   327,    43,    44,
      36,    37,   557,   333,    78,   335,   336,    45,    46,   339,
     340,   379,   380,    18,   344,    36,    37,    43,    44,   297,
       4,    43,    44,    45,    46,    63,   581,    60,     6,   359,
     477,    14,    70,    71,    72,    73,    74,   279,     7,    78,
      60,    63,    25,    80,   462,   375,    64,    30,    70,    71,
      72,    73,    74,   608,   384,    19,    52,   425,    80,   614,
      52,    14,    78,   393,    81,   433,   396,   485,    51,    52,
      78,    78,    25,    58,    57,   441,    59,    30,    51,    52,
      70,    71,    55,    73,    74,    78,    59,    70,    71,    79,
     545,    79,    79,    15,    16,    78,    49,    50,    51,    52,
       6,   519,    52,    60,    57,     8,    59,    78,    60,    60,
      80,   353,   354,   443,   480,    53,   534,    70,    71,    78,
      80,    43,    44,    45,    46,    78,    80,    83,   458,    78,
     372,   461,    79,    75,   500,    70,    71,    65,    73,    74,
     558,    63,    79,    79,    79,    21,    88,   602,    70,    71,
      72,    73,    74,    78,    51,    11,   611,    99,    11,   525,
     526,    32,   104,   105,   106,   495,   496,   497,   498,   499,
      79,   537,   538,    80,    51,    52,   118,    28,    55,   121,
     546,   547,    59,    34,    28,   427,    79,    38,    39,    79,
      34,    79,   134,   135,    38,    39,    14,   563,    79,    64,
      78,    52,   144,    54,    78,   147,    18,    25,    52,    24,
      54,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,    80,    80,    79,    60,    14,   557,    59,    14,
      41,    81,   474,    51,    52,    80,    52,    25,    18,    57,
      25,    59,    30,    79,    18,   487,    70,    71,    72,    73,
      74,   581,    70,    71,   196,   197,   198,   199,    80,    14,
      78,   203,   204,    51,    52,    18,    51,    52,    26,    57,
      25,    59,    57,    83,    59,    60,    70,    71,   608,    73,
      74,    79,    70,    71,   614,    70,    71,    83,   530,    60,
      78,    80,    31,    78,    80,    18,    51,    52,    81,    18,
      20,   543,    57,    65,    59,   247,    14,   249,   550,   251,
      14,    80,     6,   555,   556,    70,    71,    25,    65,    78,
      35,    25,    78,    78,   566,   567,     8,     5,    60,   271,
     572,   573,   574,    64,    41,    14,    41,    80,   280,   281,
      80,    51,   584,    51,    52,    11,    25,    51,    52,    57,
      14,    59,    60,    57,    84,    59,    60,    52,    48,    52,
      60,    25,    70,    71,   606,    79,    70,    71,    80,    80,
      78,   613,    51,    52,    78,    78,    43,    79,    57,    18,
      59,    15,    16,   325,    26,    34,    48,    51,    52,    80,
      79,    70,    71,    57,    16,    59,    80,    18,    38,    78,
      80,    29,    60,   345,    79,    18,    70,    71,    34,    43,
      44,    45,    46,    18,    78,    43,    44,    45,    46,    65,
      65,    43,    44,    45,    46,    80,    80,    31,    35,    63,
      80,    34,    80,    35,    18,    63,    70,    71,    72,    73,
      74,    63,    70,    71,    72,    73,    74,   389,    70,    71,
      72,    73,    74,    18,    40,    40,   398,    18,   400,    34,
      80,    80,    18,   405,    43,    44,    45,    46,    80,    43,
      44,    45,    46,    18,    34,    18,    31,    34,    18,    80,
      80,    80,    31,    80,    63,    43,   428,    45,    46,    63,
       1,    70,    71,    72,    73,    74,    70,    71,    72,    73,
      74,   274,   444,   355,    83,    63,    80,    43,    44,    45,
      46,    13,    70,    71,    72,    73,    74,   389,   183,   583,
     578,   489,   455,   244,   425,    43,   396,    63,    46,   342,
     472,   473,    -1,    -1,    70,    71,    72,    73,    74,    43,
      44,    45,    46,    -1,    80,    63,    -1,    -1,    -1,   491,
     492,    -1,    70,    71,    72,    73,    74,    -1,    -1,    63,
      43,    44,    45,    46,    -1,    -1,    70,    71,    72,    73,
      74,    -1,    43,    44,    45,    46,    80,    60,    -1,    -1,
      63,    64,    65,    -1,    -1,    -1,    -1,    70,    71,    72,
      73,    74,    63,    -1,    -1,    -1,    79,    -1,    -1,    70,
      71,    72,    73,    74,    43,    44,    45,    46,    79,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    43,    44,    45,    46,
      -1,    -1,    -1,    -1,    63,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    71,    72,    73,    74,    63,    -1,    -1,    -1,
      79,    -1,    -1,    70,    71,    72,    73,    74,    40,    -1,
      -1,    43,    44,    45,    46,    41,    -1,    43,    44,    45,
      46,    41,    -1,    43,    44,    45,    46,    -1,    -1,    -1,
      -1,    63,    -1,    -1,    -1,    -1,    -1,    63,    70,    71,
      72,    73,    74,    63,    70,    71,    72,    73,    74,    -1,
      70,    71,    72,    73,    74,    42,    43,    44,    45,    46,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    43,    44,    45,    46,    -1,    63,    43,    44,    45,
      46,    -1,    -1,    70,    71,    72,    73,    74,    60,    -1,
      -1,    63,    64,    65,    -1,    -1,    -1,    63,    70,    71,
      72,    73,    74,    -1,    70,    71,    72,    73,    74
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,    86,    87,    88,    88,     0,     4,    19,    94,
     101,    52,    52,    87,    87,     5,    21,   101,     6,     7,
      52,    87,    78,   107,     5,    87,    78,    87,    52,    96,
     108,    87,   104,    83,    87,    79,    81,    95,   108,    17,
      20,    23,    24,    33,    87,    80,     8,     9,    10,    97,
      79,    81,    52,    52,   108,   102,    52,   108,    87,    12,
      13,    14,    52,    98,    80,    98,     5,     5,    89,    81,
      87,   109,   111,    81,    18,    53,    78,    80,    81,    87,
      87,    80,    81,    87,    22,    78,    87,    98,    27,    52,
     131,    18,    31,    34,    39,    98,     4,    90,    14,    25,
      51,    52,    57,    59,    70,    71,    78,   131,   132,    51,
      52,    56,    59,    78,    99,   131,   135,    87,    60,     6,
      87,    60,    78,   108,     7,   105,    80,   132,    78,    81,
      64,    19,    91,    78,    25,    78,   132,   133,   134,    52,
     131,    81,    52,   110,    78,   132,    51,    78,    58,   132,
     132,    30,   132,    16,    43,    44,    45,    46,    63,    70,
      71,    72,    73,    74,    82,    78,   135,    79,    15,    16,
      70,    71,    73,    74,   100,    96,   132,   107,    95,   132,
      99,    79,   106,     6,    87,    29,    99,    52,    60,   110,
     122,   131,   132,   133,   132,   133,    60,    64,    65,    74,
      41,    43,    44,     8,    60,    80,   132,   132,    60,    79,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
     132,    53,   135,    79,   135,   135,   135,   135,   135,    80,
      87,    78,    80,    87,    79,    80,    78,   106,    87,    79,
      87,    87,    80,    79,    83,    79,   132,    60,   132,    60,
     132,    60,   102,   133,   133,   132,   132,    79,    83,    65,
      79,    87,    87,    87,    21,    87,    87,    78,   113,     6,
       7,    92,   103,    87,   116,   122,   132,   132,   132,   109,
      15,    16,    80,    52,    59,    51,    96,    96,    95,    98,
      95,    87,   131,    11,    11,   123,   132,    32,    89,   103,
     132,   132,    87,    79,    79,    79,    79,    80,    79,    96,
      64,    78,    78,    93,    42,   125,   108,    24,    18,    41,
      41,    80,    87,    80,    79,    60,   102,   102,   109,    59,
      26,    80,    81,   102,    41,   102,   102,    87,    87,    80,
     114,   115,   132,    87,   126,    87,   129,    52,   133,    98,
      87,   117,   110,   109,   109,    18,    87,   109,    80,    83,
     125,    51,    52,    55,    59,   127,   128,   131,    87,    52,
     130,   132,    79,    37,    80,    80,    81,    28,    34,    38,
      39,    54,   131,    18,    80,   103,   103,    90,    18,    87,
      26,    51,    60,    83,    79,    60,    83,   103,   124,   116,
      60,    80,    49,    50,    52,    78,   112,   133,   131,   131,
      80,    81,    92,    31,   109,    18,    18,   110,    20,   114,
      30,    51,    52,   120,   121,    65,   126,    80,    65,   129,
       6,   123,   132,    87,   117,    78,    78,    82,   112,   133,
      35,    35,    43,     5,     8,   117,    60,    64,   110,    41,
      41,    80,   110,    80,    51,    84,    52,   128,   103,   132,
      11,    80,    34,    52,    52,    48,    79,   117,   102,    52,
      87,   132,    92,    60,    80,   110,   110,    80,   121,   109,
      78,   116,   133,    79,    79,    43,    18,   117,    82,    26,
     119,    15,    16,   132,   123,   103,    80,    80,   107,   102,
      35,   133,    34,   103,    48,    30,   120,    18,   132,   132,
      80,    93,   109,   109,   109,    87,   126,   102,    80,    36,
      37,   118,    60,    60,    38,    40,    40,    93,   117,    79,
     117,    18,   112,   133,    34,   102,    18,    65,    65,    80,
     102,   102,   117,    80,   103,    31,    35,    35,   112,   133,
     117,    34,   102,   102,   117,   117,   117,   103,    36,    37,
     110,   102,   102,    35,   103,    80,   117,   117,   103,   103,
     109,   133,    80,   117,   117,   102,   117,   103,   103,    18,
      18,   103,   103,   103,   117,   119,    40,    40,   109,    18,
     118,   103,    80,    80,    34,    18,   117,   117,    80,    34,
      18,    80,    31,    18,   110,    34,    80,    80,   103,    18,
     109,    31,   110,    80,   103,   109
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1464 of yacc.c  */
#line 666 "vhd2vl.y"
    {
        slist *sl;
          sl=output_timescale((yyvsp[(1) - (5)].sl));
          sl=addsl(sl,(yyvsp[(2) - (5)].sl));
          sl=addsl(sl,(yyvsp[(3) - (5)].sl));
          sl=addsl(sl,(yyvsp[(4) - (5)].sl));
          sl=addsl(sl,(yyvsp[(5) - (5)].sl));
          sl=addtxt(sl,"\nendmodule\n");
          slprint(sl);
          (yyval.n)=0;
        ;}
    break;

  case 3:

/* Line 1464 of yacc.c  */
#line 681 "vhd2vl.y"
    {
        slist *sl;
          sl=addsl((yyvsp[(1) - (3)].sl),(yyvsp[(2) - (3)].sl));
          sl=addsl(sl,(yyvsp[(3) - (3)].sl));
          sl=addtxt(sl,"\nendmodule\n");
          slprint(sl);
          (yyval.n)=0;
        ;}
    break;

  case 4:

/* Line 1464 of yacc.c  */
#line 689 "vhd2vl.y"
    {
        slist *sl;
          sl=addsl((yyvsp[(1) - (3)].sl),(yyvsp[(2) - (3)].sl));
          sl=addsl(sl,(yyvsp[(3) - (3)].sl));
          sl=addtxt(sl,"\nendmodule\n");
          slprint(sl);
          (yyval.n)=0;
        ;}
    break;

  case 5:

/* Line 1464 of yacc.c  */
#line 700 "vhd2vl.y"
    {(yyval.sl)=NULL; ;}
    break;

  case 6:

/* Line 1464 of yacc.c  */
#line 701 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].sl); ;}
    break;

  case 7:

/* Line 1464 of yacc.c  */
#line 704 "vhd2vl.y"
    {(yyval.sl)=addtxt(indents[indent],(yyvsp[(1) - (1)].txt));;}
    break;

  case 8:

/* Line 1464 of yacc.c  */
#line 705 "vhd2vl.y"
    {
           slist *sl;
           sl=addtxt(indents[indent],(yyvsp[(1) - (2)].txt));
           (yyval.sl)=addsl(sl,(yyvsp[(2) - (2)].sl));;}
    break;

  case 9:

/* Line 1464 of yacc.c  */
#line 711 "vhd2vl.y"
    {(yyval.txt)=NULL;;}
    break;

  case 11:

/* Line 1464 of yacc.c  */
#line 713 "vhd2vl.y"
    {(yyval.txt)=NULL;;}
    break;

  case 13:

/* Line 1464 of yacc.c  */
#line 715 "vhd2vl.y"
    {(yyval.txt)=NULL;;}
    break;

  case 15:

/* Line 1464 of yacc.c  */
#line 718 "vhd2vl.y"
    {skipRem = 1;;}
    break;

  case 16:

/* Line 1464 of yacc.c  */
#line 719 "vhd2vl.y"
    {skipRem = 0;;}
    break;

  case 17:

/* Line 1464 of yacc.c  */
#line 723 "vhd2vl.y"
    {
            slist *sl;
            sglist *p;
              sl=addtxt(NULL,"\nmodule ");
              sl=addtxt(sl,(yyvsp[(2) - (14)].txt)); /* NAME */
              sl=addtxt(sl,"(\n");
              /* Add the signal list */
              p=io_list;
              for(;;){
                sl=addtxt(sl,p->name);
                p=p->next;
                if(p)
                  sl=addtxt(sl,",\n");
                else{
                  sl=addtxt(sl,"\n");
                  break;
                }
              }
              sl=addtxt(sl,");\n\n");
              sl=addsl(sl,(yyvsp[(6) - (14)].sl)); /* rem */
              sl=addsl(sl,(yyvsp[(7) - (14)].sl)); /* portlist */
              sl=addtxt(sl,"\n");
              p=io_list;
              do{
                sl=addptxt(sl,&(p->type));
                /*sl=addtxt(sl,p->type);*/
                sl=addpar(sl,p->range);
                sl=addtxt(sl,p->name);
                /* sl=addpost(sl,p->range); */
                sl=addtxt(sl,";\n");
                p=p->next;
              } while(p!=NULL);
              sl=addtxt(sl,"\n");
              sl=addsl(sl,(yyvsp[(10) - (14)].sl)); /* rem2 */
              (yyval.sl)=addtxt(sl,"\n");
            ;}
    break;

  case 18:

/* Line 1464 of yacc.c  */
#line 760 "vhd2vl.y"
    {
            slist *sl;
            sglist *p;
              if (0) fprintf(stderr,"matched ENTITY GENERIC\n");
              sl=addtxt(NULL,"\nmodule ");
              sl=addtxt(sl,(yyvsp[(2) - (23)].txt)); /* NAME */
              sl=addtxt(sl,"(\n");
              /* Add the signal list */
              p=io_list;
              for(;;){
                sl=addtxt(sl,p->name);
                p=p->next;
                if(p)
                  sl=addtxt(sl,",\n");
                else{
                  sl=addtxt(sl,"\n");
                  break;
                }
              }
              sl=addtxt(sl,");\n\n");
              sl=addsl(sl,(yyvsp[(7) - (23)].sl));  /* rem */
              sl=addsl(sl,(yyvsp[(8) - (23)].sl));  /* genlist */
              sl=addsl(sl,(yyvsp[(11) - (23)].sl)); /* rem */
              sl=addsl(sl,(yyvsp[(15) - (23)].sl)); /* rem */
              sl=addsl(sl,(yyvsp[(16) - (23)].sl)); /* portlist */
              sl=addtxt(sl,"\n");
              p=io_list;
              do{
                sl=addptxt(sl,&(p->type));
                /*sl=addtxt(sl,p->type);*/
                sl=addpar(sl,p->range);
                sl=addtxt(sl,p->name);
                sl=addtxt(sl,";\n");
                p=p->next;
              } while(p!=NULL);
              sl=addtxt(sl,"\n");
              sl=addsl(sl,(yyvsp[(19) - (23)].sl)); /* rem2 */
              (yyval.sl)=addtxt(sl,"\n");
            ;}
    break;

  case 19:

/* Line 1464 of yacc.c  */
#line 802 "vhd2vl.y"
    {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[(3) - (7)].v)); /* type */
            p=(yyvsp[(1) - (7)].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,"=");
              sl=addsl(sl, (yyvsp[(6) - (7)].e)->sl); /* expr */
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[(7) - (7)].sl)); /* rem */
          } else {
            (yyval.sl)=NULL;
          }
         ;}
    break;

  case 20:

/* Line 1464 of yacc.c  */
#line 823 "vhd2vl.y"
    {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[(3) - (9)].v)); /* type */
            p=(yyvsp[(1) - (9)].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,"=");
              sl=addsl(sl, (yyvsp[(6) - (9)].e)->sl); /* expr */
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[(8) - (9)].sl)); /* rem */
            (yyval.sl)=addsl(sl,(yyvsp[(9) - (9)].sl)); /* genlist */
          } else {
            (yyval.sl)=NULL;
          }
         ;}
    break;

  case 21:

/* Line 1464 of yacc.c  */
#line 845 "vhd2vl.y"
    {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[(3) - (6)].v)); /* type */
            p=(yyvsp[(1) - (6)].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[(5) - (6)].sl)); /* rem */
            (yyval.sl)=addsl(sl,(yyvsp[(6) - (6)].sl)); /* genlist */
          } else {
            (yyval.sl)=NULL;
          }
         ;}
    break;

  case 22:

/* Line 1464 of yacc.c  */
#line 865 "vhd2vl.y"
    {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[(3) - (4)].v)); /* type */
            p=(yyvsp[(1) - (4)].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].sl)); /* rem */
          } else {
            (yyval.sl)=NULL;
          }
         ;}
    break;

  case 23:

/* Line 1464 of yacc.c  */
#line 886 "vhd2vl.y"
    {
            slist *sl;

              if(dolist){
                io_list=NULL;
                sl=setup_port((yyvsp[(1) - (5)].sg),(yyvsp[(3) - (5)].n),(yyvsp[(4) - (5)].v));  /* modifies io_list global */
                (yyval.sl)=addsl(sl,(yyvsp[(5) - (5)].sl));
              } else{
                free((yyvsp[(5) - (5)].sl));
                free((yyvsp[(4) - (5)].v));
              }
            ;}
    break;

  case 24:

/* Line 1464 of yacc.c  */
#line 899 "vhd2vl.y"
    {
            slist *sl;

              if(dolist){
                sl=setup_port((yyvsp[(1) - (7)].sg),(yyvsp[(3) - (7)].n),(yyvsp[(4) - (7)].v));  /* modifies io_list global */
                sl=addsl(sl,(yyvsp[(6) - (7)].sl));
                (yyval.sl)=addsl(sl,(yyvsp[(7) - (7)].sl));
              } else{
                free((yyvsp[(6) - (7)].sl));
                free((yyvsp[(4) - (7)].v));
              }
            ;}
    break;

  case 25:

/* Line 1464 of yacc.c  */
#line 912 "vhd2vl.y"
    {
            slist *sl;
              fprintf(stderr,"Warning on line %d: "
                "port default initialization ignored\n",lineno);
              if(dolist){
                io_list=NULL;
                sl=setup_port((yyvsp[(1) - (8)].sg),(yyvsp[(3) - (8)].n),(yyvsp[(4) - (8)].v));  /* modifies io_list global */
                (yyval.sl)=addsl(sl,(yyvsp[(8) - (8)].sl));
              } else{
                free((yyvsp[(8) - (8)].sl));
                free((yyvsp[(4) - (8)].v));
              }
            ;}
    break;

  case 26:

/* Line 1464 of yacc.c  */
#line 926 "vhd2vl.y"
    {
            slist *sl;
              fprintf(stderr,"Warning on line %d: "
                "port default initialization ignored\n",lineno);
              if(dolist){
                sl=setup_port((yyvsp[(1) - (10)].sg),(yyvsp[(3) - (10)].n),(yyvsp[(4) - (10)].v));  /* modifies io_list global */
                sl=addsl(sl,(yyvsp[(9) - (10)].sl));
                (yyval.sl)=addsl(sl,(yyvsp[(10) - (10)].sl));
              } else{
                free((yyvsp[(9) - (10)].sl));
                free((yyvsp[(4) - (10)].v));
              }
            ;}
    break;

  case 27:

/* Line 1464 of yacc.c  */
#line 941 "vhd2vl.y"
    { (yyval.n)=0;;}
    break;

  case 28:

/* Line 1464 of yacc.c  */
#line 942 "vhd2vl.y"
    { (yyval.n)=1; ;}
    break;

  case 29:

/* Line 1464 of yacc.c  */
#line 943 "vhd2vl.y"
    { (yyval.n)=2; ;}
    break;

  case 30:

/* Line 1464 of yacc.c  */
#line 946 "vhd2vl.y"
    {
                (yyval.v)=new_vrange(tSCALAR);
              ;}
    break;

  case 31:

/* Line 1464 of yacc.c  */
#line 949 "vhd2vl.y"
    {
                fprintf(stderr,"Warning on line %d: integer range ignored\n",lineno);
                (yyval.v)=new_vrange(tSCALAR);
                (yyval.v)->nlo = addtxt(NULL,"0");
                (yyval.v)->nhi = addtxt(NULL,"31");
              ;}
    break;

  case 32:

/* Line 1464 of yacc.c  */
#line 955 "vhd2vl.y"
    {
                (yyval.v)=new_vrange(tSCALAR);
                (yyval.v)->nlo = addtxt(NULL,"0");
                (yyval.v)->nhi = addtxt(NULL,"31");
              ;}
    break;

  case 33:

/* Line 1464 of yacc.c  */
#line 960 "vhd2vl.y"
    {(yyval.v)=(yyvsp[(3) - (4)].v);;}
    break;

  case 34:

/* Line 1464 of yacc.c  */
#line 961 "vhd2vl.y"
    {
              sglist *sg;

                sg=lookup(type_list,(yyvsp[(1) - (1)].txt));
                if(sg)
                  (yyval.v)=sg->range;
                else{
                  fprintf(stderr,"Undefined type '%s' on line %d\n",(yyvsp[(1) - (1)].txt),lineno);
                  YYABORT;
                }
              ;}
    break;

  case 35:

/* Line 1464 of yacc.c  */
#line 975 "vhd2vl.y"
    {
              (yyval.v)=new_vrange(tVRANGE);
              (yyval.v)->nhi=(yyvsp[(1) - (3)].e)->sl;
              (yyval.v)->nlo=(yyvsp[(3) - (3)].e)->sl;
              (yyval.v)->sizeval = -1; /* undefined size */
              /* calculate the width of this vrange */
              if ((yyvsp[(1) - (3)].e)->op == 'n' && (yyvsp[(3) - (3)].e)->op == 'n') {
                if ((yyvsp[(2) - (3)].n)==-1) { /* (nhi:natural downto nlo:natural) */
                  (yyval.v)->sizeval = (yyvsp[(1) - (3)].e)->value - (yyvsp[(3) - (3)].e)->value + 1;
                } else {      /* (nhi:natural to     nlo:natural) */
                  (yyval.v)->sizeval = (yyvsp[(3) - (3)].e)->value - (yyvsp[(1) - (3)].e)->value + 1;
                }
              } else {
                /* make an expression to calculate the width of this vrange:
                 * create an expression that calculates: 
                 *   size expr = (simple_expr1) - (simple_expr2) + 1 
                 */
                expdata *size_expr1  = xmalloc(sizeof(expdata));
                expdata *size_expr2  = xmalloc(sizeof(expdata));
                expdata *diff12  = xmalloc(sizeof(expdata));
                expdata *plusone = xmalloc(sizeof(expdata));
                expdata *finalexpr = xmalloc(sizeof(expdata));
                size_expr1->sl = addwrap("(",(yyvsp[(1) - (3)].e)->sl,")");
                size_expr2->sl = addwrap("(",(yyvsp[(3) - (3)].e)->sl,")");
                plusone->op='t';
                plusone->sl=addtxt(NULL,"1");
                if ((yyvsp[(2) - (3)].n)==-1) {
                  /* (simple_expr1 downto simple_expr1) */
                  diff12 = addexpr(size_expr1,'-',"-",size_expr2);
                } else {
                  /* (simple_expr1   to   simple_expr1) */
                  diff12 = addexpr(size_expr2,'-',"-",size_expr1);
                }
                finalexpr = addexpr(diff12,'+',"+",plusone);
                finalexpr->sl = addwrap("(",finalexpr->sl,")");
                (yyval.v)->size_expr = finalexpr->sl;
              }
            ;}
    break;

  case 36:

/* Line 1464 of yacc.c  */
#line 1013 "vhd2vl.y"
    {
              (yyval.v)=new_vrange(tSUBSCRIPT);
              (yyval.v)->nlo=(yyvsp[(1) - (1)].e)->sl;
          ;}
    break;

  case 37:

/* Line 1464 of yacc.c  */
#line 1017 "vhd2vl.y"
    {
              /* lookup NAME and copy its vrange */
              sglist *sg = NULL;
              if((sg=lookup(io_list,(yyvsp[(1) - (3)].txt)))==NULL) {
                sg=lookup(sig_list,(yyvsp[(1) - (3)].txt));
              }
              if(sg) {
                (yyval.v) = sg->range;
              } else {
                fprintf(stderr,"Undefined range \"%s'range\" on line %d\n",(yyvsp[(1) - (3)].txt),lineno);
                YYABORT;
              }
          ;}
    break;

  case 38:

/* Line 1464 of yacc.c  */
#line 1032 "vhd2vl.y"
    {(yyval.n)=-1;}
    break;

  case 39:

/* Line 1464 of yacc.c  */
#line 1033 "vhd2vl.y"
    {(yyval.n)=1;}
    break;

  case 40:

/* Line 1464 of yacc.c  */
#line 1038 "vhd2vl.y"
    {
               slist *sl;
                 sl=addsl((yyvsp[(6) - (15)].sl),(yyvsp[(7) - (15)].sl));
                 sl=addtxt(sl,"\n");
                 (yyval.sl)=addsl(sl,(yyvsp[(10) - (15)].sl));
               ;}
    break;

  case 41:

/* Line 1464 of yacc.c  */
#line 1047 "vhd2vl.y"
    {indent= indent < MAXINDENT ? indent + 1 : indent;;}
    break;

  case 42:

/* Line 1464 of yacc.c  */
#line 1050 "vhd2vl.y"
    {indent= indent > 0 ? indent - 1 : indent;;}
    break;

  case 43:

/* Line 1464 of yacc.c  */
#line 1053 "vhd2vl.y"
    {(yyval.sl)=NULL;;}
    break;

  case 44:

/* Line 1464 of yacc.c  */
#line 1054 "vhd2vl.y"
    {
            sglist *sg;
            slist *sl;
            int size;

              if((yyvsp[(5) - (7)].v)->vtype==tSUBSCRIPT)
                size=1;
              else
                size=-1;
              sl=(yyvsp[(1) - (7)].sl);
              sg=(yyvsp[(3) - (7)].sg);
              for(;;){
                sg->type=wire;
                sg->range=(yyvsp[(5) - (7)].v);
                sl=addptxt(sl,&(sg->type));
                sl=addpar(sl,(yyvsp[(5) - (7)].v));
                sl=addtxt(sl,sg->name);
                sl=addpost(sl,(yyvsp[(5) - (7)].v));
                sl=addtxt(sl,";");
                if(sg->next == NULL)
                  break;
                sl=addtxt(sl," ");
                sg=sg->next;
              }
              sg->next=sig_list;
              sig_list=(yyvsp[(3) - (7)].sg);
              (yyval.sl)=addrem(sl,(yyvsp[(7) - (7)].sl));
            ;}
    break;

  case 45:

/* Line 1464 of yacc.c  */
#line 1082 "vhd2vl.y"
    {
            slist * sl;
              sl=addtxt((yyvsp[(1) - (10)].sl),"parameter ");
              sl=addtxt(sl,(yyvsp[(3) - (10)].txt));
              sl=addtxt(sl," = ");
              sl=addsl(sl,(yyvsp[(8) - (10)].e)->sl);
              sl=addtxt(sl,";");
              (yyval.sl)=addrem(sl,(yyvsp[(10) - (10)].sl));
            ;}
    break;

  case 46:

/* Line 1464 of yacc.c  */
#line 1091 "vhd2vl.y"
    {
            slist *sl, *sl2;
            sglist *p;
            int n,k;
              n=0;
              sl=NULL;
              p=(yyvsp[(6) - (9)].sg);
              for(;;){
                sl=addtxt(sl,"  ");
                sl=addtxt(sl,p->name);
                sl=addtxt(sl," = ");
                sl=addval(sl,n++);
                p=p->next;
                if(p==NULL){
                  sl=addtxt(sl,";\n");
                  break;
                } else
                  sl=addtxt(sl,",\n");
              }
              n--;
              k=find_msb(n);
              sl2=addtxt(NULL,"parameter [");
              sl2=addval(sl2,k);
              sl2=addtxt(sl2,":0]\n");
              sl=addsl(sl2,sl);
              sl=addsl((yyvsp[(1) - (9)].sl),sl);
              (yyval.sl)=addrem(sl,(yyvsp[(9) - (9)].sl));
              p=xmalloc(sizeof(sglist));
              p->name=(yyvsp[(3) - (9)].txt);
              if(k>0) {
                p->range=new_vrange(tVRANGE);
                p->range->sizeval = k+1;
                p->range->nhi=addval(NULL,k);
                p->range->nlo=addtxt(NULL,"0");
              } else {
                p->range=new_vrange(tSCALAR);
              }
              p->next=type_list;
              type_list=p;
            ;}
    break;

  case 47:

/* Line 1464 of yacc.c  */
#line 1131 "vhd2vl.y"
    {
            slist *sl=NULL;
            sglist *p;
              (yyval.sl)=addrem(sl,(yyvsp[(12) - (12)].sl));
              p=xmalloc(sizeof(sglist));
              p->name=(yyvsp[(3) - (12)].txt);
              p->range=(yyvsp[(10) - (12)].v);
              p->range->xhi=(yyvsp[(7) - (12)].v)->nhi;
              p->range->xlo=(yyvsp[(7) - (12)].v)->nlo;
              p->next=type_list;
              type_list=p;
            ;}
    break;

  case 48:

/* Line 1464 of yacc.c  */
#line 1144 "vhd2vl.y"
    {
              (yyval.sl)=addsl((yyvsp[(1) - (20)].sl),(yyvsp[(20) - (20)].sl)); /* a_decl, rem4 */
              free((yyvsp[(3) - (20)].txt)); /* NAME */
              free((yyvsp[(10) - (20)].sl)); /* rem2 */
              free((yyvsp[(14) - (20)].sl));/* rem3 */
            ;}
    break;

  case 49:

/* Line 1464 of yacc.c  */
#line 1152 "vhd2vl.y"
    {(yyval.txt)=NULL;;}
    break;

  case 50:

/* Line 1464 of yacc.c  */
#line 1153 "vhd2vl.y"
    {
             if (0) fprintf(stderr,"matched opt_generic\n");
             free((yyvsp[(4) - (8)].sl));  /* rem */
             free((yyvsp[(8) - (8)].sl));  /* rem */
             (yyval.txt)=NULL;
            ;}
    break;

  case 51:

/* Line 1464 of yacc.c  */
#line 1161 "vhd2vl.y"
    {dolist = 0;;}
    break;

  case 52:

/* Line 1464 of yacc.c  */
#line 1162 "vhd2vl.y"
    {dolist = 1;;}
    break;

  case 53:

/* Line 1464 of yacc.c  */
#line 1165 "vhd2vl.y"
    {
         sglist * sg;
           if(dolist){
             sg=xmalloc(sizeof(sglist));
             sg->name=(yyvsp[(1) - (2)].txt);
             sg->next=NULL;
             (yyval.sg)=sg;
           } else{
             free((yyvsp[(1) - (2)].txt));
             (yyval.sg)=NULL;
           }
           free((yyvsp[(2) - (2)].sl));
         ;}
    break;

  case 54:

/* Line 1464 of yacc.c  */
#line 1178 "vhd2vl.y"
    {
         sglist * sg;
           if(dolist){
             sg=xmalloc(sizeof(sglist));
             sg->name=(yyvsp[(1) - (4)].txt);
             sg->next=(yyvsp[(4) - (4)].sg);
             (yyval.sg)=sg;
           } else{
             free((yyvsp[(1) - (4)].txt));
             (yyval.sg)=NULL;
           }
           free((yyvsp[(3) - (4)].sl));
         ;}
    break;

  case 55:

/* Line 1464 of yacc.c  */
#line 1193 "vhd2vl.y"
    {(yyval.sl)=addind((yyvsp[(1) - (1)].sl));;}
    break;

  case 56:

/* Line 1464 of yacc.c  */
#line 1195 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (9)].sl),indents[indent]);
           sl=addtxt(sl,"assign ");
           sl=addsl(sl,(yyvsp[(2) - (9)].ss)->sl);
           findothers((yyvsp[(2) - (9)].ss),(yyvsp[(7) - (9)].sl));
           free((yyvsp[(2) - (9)].ss));
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(7) - (9)].sl));
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[(9) - (9)].sl));
         ;}
    break;

  case 57:

/* Line 1464 of yacc.c  */
#line 1208 "vhd2vl.y"
    {
         slist *sl;
         sglist *sg;
         char *s;
           sl=addsl((yyvsp[(1) - (11)].sl),indents[indent]);
           sl=addtxt(sl,"always @(*) begin\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"  case(");
           sl=addsl(sl,(yyvsp[(3) - (11)].e)->sl);
           free((yyvsp[(3) - (11)].e));
           sl=addtxt(sl,")\n");
           if((yyvsp[(5) - (11)].sl))
             sl=addsl(sl,(yyvsp[(5) - (11)].sl));
           s=sbottom((yyvsp[(7) - (11)].ss)->sl);
           if((sg=lookup(io_list,s))==NULL)
             sg=lookup(sig_list,s);
           if(sg)
             sg->type=reg;
           findothers((yyvsp[(7) - (11)].ss),(yyvsp[(10) - (11)].sl));
           free((yyvsp[(7) - (11)].ss));
           sl=addsl(sl,(yyvsp[(10) - (11)].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"  endcase\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[(11) - (11)].sl));
         ;}
    break;

  case 58:

/* Line 1464 of yacc.c  */
#line 1236 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (15)].sl),indents[indent]);
           sl=addtxt(sl,(yyvsp[(4) - (15)].txt)); /* NAME2 */
           sl=addtxt(sl," ");
           sl=addtxt(sl,(yyvsp[(2) - (15)].txt)); /* NAME1 */
           sl=addtxt(sl,"(\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[(10) - (15)].sl));  /* map_list */
           sl=addtxt(sl,");\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[(15) - (15)].sl)); /* a_body */
         ;}
    break;

  case 59:

/* Line 1464 of yacc.c  */
#line 1249 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (21)].sl),indents[indent]);
           sl=addtxt(sl,(yyvsp[(4) - (21)].txt)); /* NAME2 (component name) */
           if ((yyvsp[(5) - (21)].sl)) {
             sl=addsl(sl,(yyvsp[(5) - (21)].sl));
             sl=addsl(sl,indents[indent]);
           }
           sl=addtxt(sl," #(\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[(10) - (21)].sl)); /* (generic) map_list */
           sl=addtxt(sl,")\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,(yyvsp[(2) - (21)].txt)); /* NAME1 (instance name) */
           sl=addtxt(sl,"(\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[(17) - (21)].sl)); /* map_list */
           sl=addtxt(sl,");\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[(21) - (21)].sl)); /* a_body */
         ;}
    break;

  case 60:

/* Line 1464 of yacc.c  */
#line 1269 "vhd2vl.y"
    {
         slist *sl;
           if (0) fprintf(stderr,"process style 1\n");
           sl=add_always((yyvsp[(1) - (16)].sl),(yyvsp[(4) - (16)].sl),(yyvsp[(6) - (16)].sl),0);
           sl=addsl(sl,(yyvsp[(10) - (16)].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[(16) - (16)].sl));
         ;}
    break;

  case 61:

/* Line 1464 of yacc.c  */
#line 1279 "vhd2vl.y"
    {
           slist *sl;
             if (0) fprintf(stderr,"process style 2: if then end if\n");
             sl=add_always((yyvsp[(1) - (23)].sl),(yyvsp[(4) - (23)].sl),(yyvsp[(6) - (23)].sl),1);
             if((yyvsp[(10) - (23)].sl)){
               sl=addsl(sl,indents[indent]);
               sl=addsl(sl,(yyvsp[(10) - (23)].sl));
             }
             sl=addsl(sl,(yyvsp[(14) - (23)].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n\n");
             (yyval.sl)=addsl(sl,(yyvsp[(23) - (23)].sl));
         ;}
    break;

  case 62:

/* Line 1464 of yacc.c  */
#line 1297 "vhd2vl.y"
    {
           slist *sl;
             if (0) fprintf(stderr,"process style 3: if then elsif then end if\n");
             sl=add_always((yyvsp[(1) - (31)].sl),(yyvsp[(4) - (31)].sl),(yyvsp[(6) - (31)].sl),1);
             if((yyvsp[(10) - (31)].sl)){
               sl=addsl(sl,indents[indent]);
               sl=addsl(sl,(yyvsp[(10) - (31)].sl));
             }
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  if(");
             sl=addsl(sl,(yyvsp[(12) - (31)].sl));
             sl=addtxt(sl,") begin\n");
             sl=addsl(sl,(yyvsp[(15) - (31)].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end else begin\n");
             sl=addsl(sl,(yyvsp[(21) - (31)].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end\n");
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n\n");
             (yyval.sl)=addsl(sl,(yyvsp[(31) - (31)].sl));
         ;}
    break;

  case 63:

/* Line 1464 of yacc.c  */
#line 1324 "vhd2vl.y"
    {
           slist *sl;
             if (0) fprintf(stderr,"process style 4: if then else if then end if\n");
             sl=add_always((yyvsp[(1) - (35)].sl),(yyvsp[(4) - (35)].sl),(yyvsp[(6) - (35)].sl),1);
             if((yyvsp[(10) - (35)].sl)){
               sl=addsl(sl,indents[indent]);
               sl=addsl(sl,(yyvsp[(10) - (35)].sl));
             }
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  if(");
             sl=addsl(sl,(yyvsp[(12) - (35)].sl)); /* exprc */
             sl=addtxt(sl,") begin\n");
             sl=addsl(sl,(yyvsp[(15) - (35)].sl)); /* p_body:1 */
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end else begin\n");
             sl=addsl(sl,(yyvsp[(22) - (35)].sl)); /* p_body:2 */
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end\n");
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n\n");
             (yyval.sl)=addsl(sl,(yyvsp[(35) - (35)].sl)); /* a_body */
         ;}
    break;

  case 64:

/* Line 1464 of yacc.c  */
#line 1349 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (12)].sl),indents[indent]);
           sl=addtxt(sl,"generate ");
           sl=addtxt(sl,"if (");
           sl=addsl(sl,(yyvsp[(3) - (12)].sl)); /* exprc */
           sl=addtxt(sl,") begin\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[(6) - (12)].sl));   /* a_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endgenerate\n");
           (yyval.sl)=addsl(sl,(yyvsp[(12) - (12)].sl));    /* a_body:2 */
         ;}
    break;

  case 65:

/* Line 1464 of yacc.c  */
#line 1365 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (16)].sl),indents[indent]);
           sl=addtxt(sl,"genvar ");
           sl=addsl(sl,(yyvsp[(3) - (16)].ss)->sl); /* signal */
           sl=addtxt(sl,";\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"generate ");
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[(3) - (16)].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[(5) - (16)].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (16)].ss)->sl); /* signal */
           sl=addtxt(sl," <= ");
           sl=addsl(sl,(yyvsp[(7) - (16)].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (16)].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(3) - (16)].ss)->sl); /* signal */
           sl=addtxt(sl," + 1) begin\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[(10) - (16)].sl));   /* a_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endgenerate\n");
           (yyval.sl)=addsl(sl,(yyvsp[(16) - (16)].sl));    /* a_body:2 */
         ;}
    break;

  case 66:

/* Line 1464 of yacc.c  */
#line 1395 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (16)].sl),indents[indent]);
           sl=addtxt(sl,"generate ");
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[(3) - (16)].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[(5) - (16)].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (16)].ss)->sl); /* signal */
           sl=addtxt(sl," >= ");
           sl=addsl(sl,(yyvsp[(7) - (16)].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (16)].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(3) - (16)].ss)->sl); /* signal */
           sl=addtxt(sl," - 1) begin\n");
           sl=addsl(sl,(yyvsp[(10) - (16)].sl));   /* a_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endgenerate\n");
           (yyval.sl)=addsl(sl,(yyvsp[(16) - (16)].sl));    /* a_body:2 */
         ;}
    break;

  case 67:

/* Line 1464 of yacc.c  */
#line 1419 "vhd2vl.y"
    {(yyval.sl)=NULL;;}
    break;

  case 68:

/* Line 1464 of yacc.c  */
#line 1420 "vhd2vl.y"
    {free((yyvsp[(1) - (1)].txt)); (yyval.sl)=NULL;;}
    break;

  case 69:

/* Line 1464 of yacc.c  */
#line 1423 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].sl);;}
    break;

  case 70:

/* Line 1464 of yacc.c  */
#line 1424 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (3)].sl); free((yyvsp[(2) - (3)].txt));;}
    break;

  case 71:

/* Line 1464 of yacc.c  */
#line 1427 "vhd2vl.y"
    {(yyval.sl)=addwrap("(",(yyvsp[(2) - (3)].sl),")");;}
    break;

  case 72:

/* Line 1464 of yacc.c  */
#line 1428 "vhd2vl.y"
    {
         clkedges[clkptr++]=(yyvsp[(5) - (5)].sl)->data.sl->data.txt[0]-'0';
         assert(clkptr < MAXEDGES);
       ;}
    break;

  case 73:

/* Line 1464 of yacc.c  */
#line 1432 "vhd2vl.y"
    {
         clkedges[clkptr++]=(yyvsp[(1) - (5)].sl)->data.sl->data.txt[0]-'0';
         clkptr++;
         assert(clkptr < MAXEDGES);
       ;}
    break;

  case 74:

/* Line 1464 of yacc.c  */
#line 1437 "vhd2vl.y"
    {
         clkedges[clkptr++]=1;
         assert(clkptr < MAXEDGES);
       ;}
    break;

  case 75:

/* Line 1464 of yacc.c  */
#line 1441 "vhd2vl.y"
    {
         clkedges[clkptr++]=0;
         assert(clkptr < MAXEDGES);
       ;}
    break;

  case 76:

/* Line 1464 of yacc.c  */
#line 1447 "vhd2vl.y"
    {dowith=1;;}
    break;

  case 77:

/* Line 1464 of yacc.c  */
#line 1449 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (2)].sl);;}
    break;

  case 78:

/* Line 1464 of yacc.c  */
#line 1450 "vhd2vl.y"
    {
            slist *sl;
              if((yyvsp[(3) - (4)].sl)){
                sl=addsl((yyvsp[(1) - (4)].sl),(yyvsp[(3) - (4)].sl));
                (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].sl));
              } else
                (yyval.sl)=addsl((yyvsp[(1) - (4)].sl),(yyvsp[(4) - (4)].sl));
            ;}
    break;

  case 79:

/* Line 1464 of yacc.c  */
#line 1458 "vhd2vl.y"
    {
            slist *sl;
              sl=addtxt(indents[indent],"    default : ");
              sl=addsl(sl,slwith);
              sl=addtxt(sl," <= ");
              if(delay && (yyvsp[(2) - (5)].n)){
                sl=addtxt(sl,"# ");
                sl=addval(sl,(yyvsp[(2) - (5)].n));
                sl=addtxt(sl," ");
              }
              if((yyvsp[(1) - (5)].e)->op == 'c')
                sl=addsl(sl,addwrap("{",(yyvsp[(1) - (5)].e)->sl,"}"));
              else
                sl=addsl(sl,(yyvsp[(1) - (5)].e)->sl);
              free((yyvsp[(1) - (5)].e));
              delay=1;
              (yyval.sl)=addtxt(sl,";\n");
            ;}
    break;

  case 80:

/* Line 1464 of yacc.c  */
#line 1477 "vhd2vl.y"
    {
            slist *sl;
              sl=addtxt(indents[indent],"    ");
              sl=addsl(sl,(yyvsp[(4) - (4)].sl));
              sl=addtxt(sl," : ");
              sl=addsl(sl,slwith);
              sl=addtxt(sl," <= ");
              if(delay && (yyvsp[(2) - (4)].n)){
                sl=addtxt(sl,"# ");
                sl=addval(sl,(yyvsp[(2) - (4)].n));
                sl=addtxt(sl," ");
              }
              if((yyvsp[(1) - (4)].e)->op == 'c')
                sl=addsl(sl,addwrap("{",(yyvsp[(1) - (4)].e)->sl,"}"));
              else
                sl=addsl(sl,(yyvsp[(1) - (4)].e)->sl);
              free((yyvsp[(1) - (4)].e));
              delay=1;
              (yyval.sl)=addtxt(sl,";\n");
            ;}
    break;

  case 81:

/* Line 1464 of yacc.c  */
#line 1498 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].sl);}
    break;

  case 82:

/* Line 1464 of yacc.c  */
#line 1499 "vhd2vl.y"
    {
         slist *sl;
         sglist *sg, *p;
           sl=addtxt((yyvsp[(1) - (7)].sl),"    reg");
           sl=addpar(sl,(yyvsp[(5) - (7)].v));
           free((yyvsp[(5) - (7)].v));
           sg=(yyvsp[(3) - (7)].sg);
           for(;;){
             sl=addtxt(sl,sg->name);
             p=sg;
             sg=sg->next;
             free(p);
             if(sg)
               sl=addtxt(sl,", ");
             else
               break;
           }
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[(7) - (7)].sl));
         ;}
    break;

  case 83:

/* Line 1464 of yacc.c  */
#line 1519 "vhd2vl.y"
    {
         slist *sl;
         sglist *sg, *p;
           sl=addtxt((yyvsp[(1) - (10)].sl),"    reg");
           sl=addpar(sl,(yyvsp[(5) - (10)].v));
           free((yyvsp[(5) - (10)].v));
           sg=(yyvsp[(3) - (10)].sg);
           for(;;){
             sl=addtxt(sl,sg->name);
             p=sg;
             sg=sg->next;
             free(p);
             if(sg)
               sl=addtxt(sl,", ");
             else
               break;
           }
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(8) - (10)].e)->sl);
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[(10) - (10)].sl));
         ;}
    break;

  case 84:

/* Line 1464 of yacc.c  */
#line 1543 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].sl);;}
    break;

  case 85:

/* Line 1464 of yacc.c  */
#line 1545 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (9)].sl),indents[indent]);
           sl=addsl(sl,(yyvsp[(2) - (9)].ss)->sl);
           findothers((yyvsp[(2) - (9)].ss),(yyvsp[(6) - (9)].e)->sl);
           sl=addtxt(sl," = ");
           if((yyvsp[(6) - (9)].e)->op == 'c')
             sl=addsl(sl,addwrap("{",(yyvsp[(6) - (9)].e)->sl,"}"));
           else
             sl=addsl(sl,(yyvsp[(6) - (9)].e)->sl);
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[(9) - (9)].sl));
         ;}
    break;

  case 86:

/* Line 1464 of yacc.c  */
#line 1559 "vhd2vl.y"
    {
         slist *sl;
         sglist *sg;
         char *s;

           s=sbottom((yyvsp[(2) - (8)].ss)->sl);
           if((sg=lookup(io_list,s))==NULL)
             sg=lookup(sig_list,s);
           if(sg)
             sg->type=reg;
           sl=addsl((yyvsp[(1) - (8)].sl),indents[indent]);
           sl=addsl(sl,(yyvsp[(2) - (8)].ss)->sl);
           findothers((yyvsp[(2) - (8)].ss),(yyvsp[(6) - (8)].sl));
           sl=addtxt(sl," <= ");
           sl=addsl(sl,(yyvsp[(6) - (8)].sl));
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[(8) - (8)].sl));
         ;}
    break;

  case 87:

/* Line 1464 of yacc.c  */
#line 1578 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (12)].sl),indents[indent]);
           sl=addtxt(sl,"if(");
           sl=addsl(sl,(yyvsp[(3) - (12)].sl));
           sl=addtxt(sl,") begin\n");
           sl=addsl(sl,(yyvsp[(6) - (12)].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           sl=addsl(sl,(yyvsp[(8) - (12)].sl));
           (yyval.sl)=addsl(sl,(yyvsp[(12) - (12)].sl));
         ;}
    break;

  case 88:

/* Line 1464 of yacc.c  */
#line 1591 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (15)].sl),indents[indent]);
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[(5) - (15)].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," <= ");
           sl=addsl(sl,(yyvsp[(7) - (15)].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," + 1) begin \n");
           sl=addsl(sl,(yyvsp[(10) - (15)].sl));    /* p_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           (yyval.sl)=addsl(sl,(yyvsp[(15) - (15)].sl));    /* p_body:2 */
         ;}
    break;

  case 89:

/* Line 1464 of yacc.c  */
#line 1613 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (15)].sl),indents[indent]);
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[(5) - (15)].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," >= ");
           sl=addsl(sl,(yyvsp[(7) - (15)].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," - 1) begin\n");
           sl=addsl(sl,(yyvsp[(10) - (15)].sl));    /* p_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           (yyval.sl)=addsl(sl,(yyvsp[(15) - (15)].sl));    /* p_body:2 */
         ;}
    break;

  case 90:

/* Line 1464 of yacc.c  */
#line 1635 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (10)].sl),indents[indent]);
           sl=addtxt(sl,"case(");
           sl=addsl(sl,(yyvsp[(3) - (10)].ss)->sl); /* signal */
           sl=addtxt(sl,")\n");
           if((yyvsp[(5) - (10)].sl)){
             sl=addsl(sl,indents[indent]);
             sl=addsl(sl,(yyvsp[(5) - (10)].sl));
           }
           sl=addsl(sl,(yyvsp[(6) - (10)].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endcase\n");
           (yyval.sl)=addsl(sl,(yyvsp[(10) - (10)].sl));
         ;}
    break;

  case 91:

/* Line 1464 of yacc.c  */
#line 1650 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (4)].sl),indents[indent]);
           sl=addtxt(sl,"disable;  //VHD2VL: add block name here\n");
           (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].sl));
         ;}
    break;

  case 92:

/* Line 1464 of yacc.c  */
#line 1656 "vhd2vl.y"
    {
         slist *sl;
           if((yyvsp[(1) - (4)].sl)){
             sl=addsl((yyvsp[(1) - (4)].sl),indents[indent]);
             (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].sl));
           }else
             (yyval.sl)=(yyvsp[(4) - (4)].sl);
         ;}
    break;

  case 93:

/* Line 1464 of yacc.c  */
#line 1666 "vhd2vl.y"
    {(yyval.sl)=NULL;;}
    break;

  case 94:

/* Line 1464 of yacc.c  */
#line 1667 "vhd2vl.y"
    {
           slist *sl;
             sl=addtxt(indents[indent],"else if(");
             sl=addsl(sl,(yyvsp[(2) - (7)].sl));
             sl=addtxt(sl,") begin\n");
             sl=addsl(sl,(yyvsp[(5) - (7)].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n");
             (yyval.sl)=addsl(sl,(yyvsp[(7) - (7)].sl));
           ;}
    break;

  case 95:

/* Line 1464 of yacc.c  */
#line 1677 "vhd2vl.y"
    {
           slist *sl;
             sl=addtxt(indents[indent],"else begin\n");
             sl=addsl(sl,(yyvsp[(3) - (4)].sl));
             sl=addsl(sl,indents[indent]);
             (yyval.sl)=addtxt(sl,"end\n");
           ;}
    break;

  case 96:

/* Line 1464 of yacc.c  */
#line 1686 "vhd2vl.y"
    {
        slist *sl;
          sl=addsl(indents[indent],(yyvsp[(2) - (8)].sl));
          sl=addtxt(sl," : begin\n");
          sl=addsl(sl,(yyvsp[(6) - (8)].sl));
          sl=addsl(sl,indents[indent]);
          sl=addtxt(sl,"end\n");
          (yyval.sl)=addsl(sl,(yyvsp[(8) - (8)].sl));
        ;}
    break;

  case 97:

/* Line 1464 of yacc.c  */
#line 1695 "vhd2vl.y"
    {
        slist *sl;
          sl=addtxt(indents[indent],"default : begin\n");
          sl=addsl(sl,(yyvsp[(6) - (7)].sl));
          sl=addsl(sl,indents[indent]);
          (yyval.sl)=addtxt(sl,"end\n");
        ;}
    break;

  case 98:

/* Line 1464 of yacc.c  */
#line 1702 "vhd2vl.y"
    { (yyval.sl)=NULL; ;}
    break;

  case 99:

/* Line 1464 of yacc.c  */
#line 1705 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].sl);;}
    break;

  case 100:

/* Line 1464 of yacc.c  */
#line 1706 "vhd2vl.y"
    {
        slist *sl;
          sl=addtxt((yyvsp[(1) - (3)].sl),",");
          (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].sl));
        ;}
    break;

  case 101:

/* Line 1464 of yacc.c  */
#line 1713 "vhd2vl.y"
    {(yyval.sl)=addvec(NULL,(yyvsp[(1) - (1)].txt));;}
    break;

  case 102:

/* Line 1464 of yacc.c  */
#line 1714 "vhd2vl.y"
    {(yyval.sl)=addvec_base(NULL,(yyvsp[(1) - (2)].txt),(yyvsp[(2) - (2)].txt));;}
    break;

  case 103:

/* Line 1464 of yacc.c  */
#line 1715 "vhd2vl.y"
    {(yyval.sl)=addtxt(NULL,(yyvsp[(1) - (1)].txt));;}
    break;

  case 104:

/* Line 1464 of yacc.c  */
#line 1718 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].ss)->sl; free((yyvsp[(1) - (1)].ss));;}
    break;

  case 105:

/* Line 1464 of yacc.c  */
#line 1719 "vhd2vl.y"
    {
            slist *sl;
              sl=addtxt((yyvsp[(1) - (3)].ss)->sl," or ");
              free((yyvsp[(1) - (3)].ss));
              (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].sl));
            ;}
    break;

  case 106:

/* Line 1464 of yacc.c  */
#line 1727 "vhd2vl.y"
    {
           slist *sl;
             if(delay && (yyvsp[(2) - (3)].n)){
               sl=addtxt(NULL,"# ");
               sl=addval(sl,(yyvsp[(2) - (3)].n));
               sl=addtxt(sl," ");
             } else
               sl=NULL;
             if((yyvsp[(1) - (3)].e)->op == 'c')
               sl=addsl(sl,addwrap("{",(yyvsp[(1) - (3)].e)->sl,"}"));
             else
               sl=addsl(sl,(yyvsp[(1) - (3)].e)->sl);
             free((yyvsp[(1) - (3)].e));
             delay=1;
             (yyval.sl)=sl;
           ;}
    break;

  case 107:

/* Line 1464 of yacc.c  */
#line 1743 "vhd2vl.y"
    {
             fprintf(stderr,"Warning on line %d: Can't translate 'expr delay WHEN exprc;' expressions\n",lineno);
             (yyval.sl)=NULL;
           ;}
    break;

  case 108:

/* Line 1464 of yacc.c  */
#line 1747 "vhd2vl.y"
    {
           slist *sl;
             sl=addtxt((yyvsp[(4) - (7)].sl)," ? ");
             if((yyvsp[(1) - (7)].e)->op == 'c')
               sl=addsl(sl,addwrap("{",(yyvsp[(1) - (7)].e)->sl,"}"));
             else
               sl=addsl(sl,(yyvsp[(1) - (7)].e)->sl);
             free((yyvsp[(1) - (7)].e));
             sl=addtxt(sl," : ");
             (yyval.sl)=addsl(sl,(yyvsp[(7) - (7)].sl));
           ;}
    break;

  case 109:

/* Line 1464 of yacc.c  */
#line 1760 "vhd2vl.y"
    {delay=0;;}
    break;

  case 110:

/* Line 1464 of yacc.c  */
#line 1763 "vhd2vl.y"
    {(yyval.n)=0;;}
    break;

  case 111:

/* Line 1464 of yacc.c  */
#line 1764 "vhd2vl.y"
    {
                set_timescale((yyvsp[(3) - (3)].txt));
		(yyval.n)=(yyvsp[(2) - (3)].n);
		;}
    break;

  case 112:

/* Line 1464 of yacc.c  */
#line 1770 "vhd2vl.y"
    {
           slist *sl;
           sl=addsl((yyvsp[(1) - (2)].sl),indents[indent]);
           (yyval.sl)=addsl(sl,(yyvsp[(2) - (2)].sl));;}
    break;

  case 113:

/* Line 1464 of yacc.c  */
#line 1774 "vhd2vl.y"
    {
           slist *sl;
             sl=addsl((yyvsp[(1) - (4)].sl),indents[indent]);
             sl=addsl(sl,(yyvsp[(2) - (4)].sl));
             sl=addtxt(sl,",\n");
             (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].sl));
           ;}
    break;

  case 114:

/* Line 1464 of yacc.c  */
#line 1783 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].sl);;}
    break;

  case 115:

/* Line 1464 of yacc.c  */
#line 1784 "vhd2vl.y"
    {
           slist *sl;
             sl=addtxt(NULL,".");
             sl=addtxt(sl,(yyvsp[(1) - (4)].txt));
             sl=addtxt(sl,"(");
             sl=addsl(sl,(yyvsp[(4) - (4)].sl));
             (yyval.sl)=addtxt(sl,")");
           ;}
    break;

  case 116:

/* Line 1464 of yacc.c  */
#line 1794 "vhd2vl.y"
    {(yyval.sl)=addvec(NULL,(yyvsp[(1) - (1)].txt));;}
    break;

  case 117:

/* Line 1464 of yacc.c  */
#line 1795 "vhd2vl.y"
    {(yyval.sl)=addsl(NULL,(yyvsp[(1) - (1)].ss)->sl);;}
    break;

  case 118:

/* Line 1464 of yacc.c  */
#line 1796 "vhd2vl.y"
    {(yyval.sl)=addval(NULL,(yyvsp[(1) - (1)].n));;}
    break;

  case 119:

/* Line 1464 of yacc.c  */
#line 1797 "vhd2vl.y"
    {(yyval.sl)=addvec_base(NULL,(yyvsp[(1) - (2)].txt),(yyvsp[(2) - (2)].txt));;}
    break;

  case 120:

/* Line 1464 of yacc.c  */
#line 1798 "vhd2vl.y"
    {(yyval.sl)=addtxt(NULL,"/* open */");;}
    break;

  case 121:

/* Line 1464 of yacc.c  */
#line 1802 "vhd2vl.y"
    {
           slist *sl;
           sl=addsl((yyvsp[(1) - (2)].sl),indents[indent]);
           (yyval.sl)=addsl(sl,(yyvsp[(2) - (2)].sl));;}
    break;

  case 122:

/* Line 1464 of yacc.c  */
#line 1806 "vhd2vl.y"
    {
           slist *sl;
             sl=addsl((yyvsp[(1) - (4)].sl),indents[indent]);
             sl=addsl(sl,(yyvsp[(2) - (4)].sl));
             sl=addtxt(sl,",\n");
             (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].sl));
           ;}
    break;

  case 123:

/* Line 1464 of yacc.c  */
#line 1813 "vhd2vl.y"
    {  /* only allow a single un-named map item */
             (yyval.sl)=addsl(NULL,(yyvsp[(2) - (2)].e)->sl);
           ;}
    break;

  case 124:

/* Line 1464 of yacc.c  */
#line 1818 "vhd2vl.y"
    {
           slist *sl;
             sl=addtxt(NULL,".");
             sl=addtxt(sl,(yyvsp[(1) - (4)].txt));
             sl=addtxt(sl,"(");
             sl=addsl(sl,(yyvsp[(4) - (4)].e)->sl);
             (yyval.sl)=addtxt(sl,")");
           ;}
    break;

  case 125:

/* Line 1464 of yacc.c  */
#line 1828 "vhd2vl.y"
    {
         slist *sl;
         slval *ss;
           ss=xmalloc(sizeof(slval));
           sl=addtxt(NULL,(yyvsp[(1) - (1)].txt));
           if(dowith){
             slwith=sl;
             dowith=0;
           }
           ss->sl=sl;
           ss->val=-1;
           ss->range=NULL;
           (yyval.ss)=ss;
         ;}
    break;

  case 126:

/* Line 1464 of yacc.c  */
#line 1842 "vhd2vl.y"
    {
         slval *ss;
         slist *sl;
           ss=xmalloc(sizeof(slval));
           sl=addtxt(NULL,(yyvsp[(1) - (4)].txt));
           sl=addpar_snug(sl,(yyvsp[(3) - (4)].v));
           if(dowith){
             slwith=sl;
             dowith=0;
           }
           ss->sl=sl;
           ss->range=(yyvsp[(3) - (4)].v);
           if((yyvsp[(3) - (4)].v)->vtype==tVRANGE) {
             ss->val=1;
           } else {
             ss->val = -1; /* width is in the vrange */
           }
           (yyval.ss)=ss;
         ;}
    break;

  case 127:

/* Line 1464 of yacc.c  */
#line 1864 "vhd2vl.y"
    {
         expdata *e;
           e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=(yyvsp[(1) - (1)].ss)->sl;
           free((yyvsp[(1) - (1)].ss));
           (yyval.e)=e;
         ;}
    break;

  case 128:

/* Line 1464 of yacc.c  */
#line 1872 "vhd2vl.y"
    {
         expdata *e;
           e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=addvec(NULL,(yyvsp[(1) - (1)].txt));
           (yyval.e)=e;
         ;}
    break;

  case 129:

/* Line 1464 of yacc.c  */
#line 1879 "vhd2vl.y"
    {
         expdata *e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=addval(NULL,(yyvsp[(1) - (1)].n));
           (yyval.e)=e;
         ;}
    break;

  case 130:

/* Line 1464 of yacc.c  */
#line 1885 "vhd2vl.y"
    {  /* e.g. 16#55aa# */
         /* XXX unify this code with addvec_base */
         expdata *e=xmalloc(sizeof(expdata));
         char *natval = xmalloc(strlen((yyvsp[(2) - (2)].txt))+34);
           e->op='t'; /* Terminal symbol */
           switch((yyvsp[(1) - (2)].n)) {
           case  2:
             sprintf(natval, "'B%s",(yyvsp[(2) - (2)].txt));
             break;
           case  8:
             sprintf(natval, "'O%s",(yyvsp[(2) - (2)].txt));
             break;
           case 10:
             sprintf(natval, "'D%s",(yyvsp[(2) - (2)].txt));
             break;
           case 16:
             sprintf(natval, "'H%s",(yyvsp[(2) - (2)].txt));
             break;
           default:
             sprintf(natval,"%d#%s#",(yyvsp[(1) - (2)].n),(yyvsp[(2) - (2)].txt));
             fprintf(stderr,"Warning on line %d: Can't translate based number %s (only bases of 2, 8, 10, and 16 are translatable)\n",lineno,natval);
           }
           e->sl=addtxt(NULL,natval);
           (yyval.e)=e;
         ;}
    break;

  case 131:

/* Line 1464 of yacc.c  */
#line 1910 "vhd2vl.y"
    {
         expdata *e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=addvec_base(NULL,(yyvsp[(1) - (2)].txt),(yyvsp[(2) - (2)].txt));
           (yyval.e)=e;
         ;}
    break;

  case 132:

/* Line 1464 of yacc.c  */
#line 1916 "vhd2vl.y"
    {
         expdata *e;
           e=xmalloc(sizeof(expdata));
           e->op='o'; /* others */
           e->sl=addothers(NULL,(yyvsp[(5) - (6)].txt));
           (yyval.e)=e;
         ;}
    break;

  case 133:

/* Line 1464 of yacc.c  */
#line 1923 "vhd2vl.y"
    { /* Vector chaining */
         slist *sl;
           sl=addtxt((yyvsp[(1) - (3)].e)->sl,",");
           sl=addsl(sl,(yyvsp[(3) - (3)].e)->sl);
           free((yyvsp[(3) - (3)].e));
           (yyvsp[(1) - (3)].e)->op='c';
           (yyvsp[(1) - (3)].e)->sl=sl;
           (yyval.e)=(yyvsp[(1) - (3)].e);
         ;}
    break;

  case 134:

/* Line 1464 of yacc.c  */
#line 1932 "vhd2vl.y"
    {(yyval.e)=addexpr(NULL,'m'," -",(yyvsp[(2) - (2)].e));;}
    break;

  case 135:

/* Line 1464 of yacc.c  */
#line 1933 "vhd2vl.y"
    {(yyval.e)=addexpr(NULL,'p'," +",(yyvsp[(2) - (2)].e));;}
    break;

  case 136:

/* Line 1464 of yacc.c  */
#line 1934 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'+'," + ",(yyvsp[(3) - (3)].e));;}
    break;

  case 137:

/* Line 1464 of yacc.c  */
#line 1935 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'-'," - ",(yyvsp[(3) - (3)].e));;}
    break;

  case 138:

/* Line 1464 of yacc.c  */
#line 1936 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'*'," * ",(yyvsp[(3) - (3)].e));;}
    break;

  case 139:

/* Line 1464 of yacc.c  */
#line 1937 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'/'," / ",(yyvsp[(3) - (3)].e));;}
    break;

  case 140:

/* Line 1464 of yacc.c  */
#line 1938 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'%'," % ",(yyvsp[(3) - (3)].e));;}
    break;

  case 141:

/* Line 1464 of yacc.c  */
#line 1939 "vhd2vl.y"
    {(yyval.e)=addexpr(NULL,'~'," ~",(yyvsp[(2) - (2)].e));;}
    break;

  case 142:

/* Line 1464 of yacc.c  */
#line 1940 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'&'," & ",(yyvsp[(3) - (3)].e));;}
    break;

  case 143:

/* Line 1464 of yacc.c  */
#line 1941 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'|'," | ",(yyvsp[(3) - (3)].e));;}
    break;

  case 144:

/* Line 1464 of yacc.c  */
#line 1942 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'^'," ^ ",(yyvsp[(3) - (3)].e));;}
    break;

  case 145:

/* Line 1464 of yacc.c  */
#line 1943 "vhd2vl.y"
    {(yyval.e)=addexpr(NULL,'~'," ~",addexpr((yyvsp[(1) - (3)].e),'^'," ^ ",(yyvsp[(3) - (3)].e)));;}
    break;

  case 146:

/* Line 1464 of yacc.c  */
#line 1944 "vhd2vl.y"
    {
       /* single argument type conversion function e.g. std_ulogic_vector(x) */
       expdata *e;
       e=xmalloc(sizeof(expdata));
       if ((yyvsp[(3) - (4)].e)->op == 'c') {
         e->sl=addwrap("{",(yyvsp[(3) - (4)].e)->sl,"}");
       } else {
         e->sl=addwrap("(",(yyvsp[(3) - (4)].e)->sl,")"); 
       }
       (yyval.e)=e;
      ;}
    break;

  case 147:

/* Line 1464 of yacc.c  */
#line 1955 "vhd2vl.y"
    {
       /* two argument type conversion e.g. to_unsigned(x, 3) */
       (yyval.e) = addnest((yyvsp[(3) - (6)].e));
      ;}
    break;

  case 148:

/* Line 1464 of yacc.c  */
#line 1959 "vhd2vl.y"
    {
       (yyval.e) = addnest((yyvsp[(3) - (6)].e));
      ;}
    break;

  case 149:

/* Line 1464 of yacc.c  */
#line 1962 "vhd2vl.y"
    {
       (yyval.e) = addnest((yyvsp[(2) - (3)].e));
      ;}
    break;

  case 150:

/* Line 1464 of yacc.c  */
#line 1968 "vhd2vl.y"
    { (yyval.sl)=(yyvsp[(1) - (1)].sl); ;}
    break;

  case 151:

/* Line 1464 of yacc.c  */
#line 1969 "vhd2vl.y"
    {
         (yyval.sl)=addwrap("(",(yyvsp[(2) - (3)].sl),")");
      ;}
    break;

  case 152:

/* Line 1464 of yacc.c  */
#line 1972 "vhd2vl.y"
    {
        slist *sl;
          sl=addtxt((yyvsp[(1) - (3)].sl)," && ");
          (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].sl));
        ;}
    break;

  case 153:

/* Line 1464 of yacc.c  */
#line 1977 "vhd2vl.y"
    {
        slist *sl;
          sl=addtxt((yyvsp[(1) - (3)].sl)," || ");
          (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].sl));
        ;}
    break;

  case 154:

/* Line 1464 of yacc.c  */
#line 1982 "vhd2vl.y"
    {
        slist *sl;
          sl=addtxt(NULL,"!");
          (yyval.sl)=addsl(sl,(yyvsp[(2) - (2)].sl));
        ;}
    break;

  case 155:

/* Line 1464 of yacc.c  */
#line 1990 "vhd2vl.y"
    {
       slist *sl;
         if((yyvsp[(1) - (3)].e)->op == 'c')
           sl=addwrap("{",(yyvsp[(1) - (3)].e)->sl,"} == ");
         else if((yyvsp[(1) - (3)].e)->op != 't')
           sl=addwrap("(",(yyvsp[(1) - (3)].e)->sl,") == ");
         else
           sl=addtxt((yyvsp[(1) - (3)].e)->sl," == ");
         if((yyvsp[(3) - (3)].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[(3) - (3)].e)->sl,"}"));
         else if((yyvsp[(3) - (3)].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[(3) - (3)].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].e)->sl);
         free((yyvsp[(1) - (3)].e));
         free((yyvsp[(3) - (3)].e));
       ;}
    break;

  case 156:

/* Line 1464 of yacc.c  */
#line 2007 "vhd2vl.y"
    {
       slist *sl;
         if((yyvsp[(1) - (3)].e)->op == 'c')
           sl=addwrap("{",(yyvsp[(1) - (3)].e)->sl,"} > ");
         else if((yyvsp[(1) - (3)].e)->op != 't')
           sl=addwrap("(",(yyvsp[(1) - (3)].e)->sl,") > ");
         else
           sl=addtxt((yyvsp[(1) - (3)].e)->sl," > ");
         if((yyvsp[(3) - (3)].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[(3) - (3)].e)->sl,"}"));
         else if((yyvsp[(3) - (3)].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[(3) - (3)].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].e)->sl);
         free((yyvsp[(1) - (3)].e));
         free((yyvsp[(3) - (3)].e));
       ;}
    break;

  case 157:

/* Line 1464 of yacc.c  */
#line 2024 "vhd2vl.y"
    {
       slist *sl;
         if((yyvsp[(1) - (4)].e)->op == 'c')
           sl=addwrap("{",(yyvsp[(1) - (4)].e)->sl,"} >= ");
         else if((yyvsp[(1) - (4)].e)->op != 't')
           sl=addwrap("(",(yyvsp[(1) - (4)].e)->sl,") >= ");
         else
           sl=addtxt((yyvsp[(1) - (4)].e)->sl," >= ");
         if((yyvsp[(4) - (4)].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[(4) - (4)].e)->sl,"}"));
         else if((yyvsp[(4) - (4)].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[(4) - (4)].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].e)->sl);
         free((yyvsp[(1) - (4)].e));
         free((yyvsp[(4) - (4)].e));
       ;}
    break;

  case 158:

/* Line 1464 of yacc.c  */
#line 2041 "vhd2vl.y"
    {
       slist *sl;
         if((yyvsp[(1) - (3)].e)->op == 'c')
           sl=addwrap("{",(yyvsp[(1) - (3)].e)->sl,"} < ");
         else if((yyvsp[(1) - (3)].e)->op != 't')
           sl=addwrap("(",(yyvsp[(1) - (3)].e)->sl,") < ");
         else
           sl=addtxt((yyvsp[(1) - (3)].e)->sl," < ");
         if((yyvsp[(3) - (3)].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[(3) - (3)].e)->sl,"}"));
         else if((yyvsp[(3) - (3)].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[(3) - (3)].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].e)->sl);
         free((yyvsp[(1) - (3)].e));
         free((yyvsp[(3) - (3)].e));
       ;}
    break;

  case 159:

/* Line 1464 of yacc.c  */
#line 2058 "vhd2vl.y"
    {
       slist *sl;
         if((yyvsp[(1) - (4)].e)->op == 'c')
           sl=addwrap("{",(yyvsp[(1) - (4)].e)->sl,"} <= ");
         else if((yyvsp[(1) - (4)].e)->op != 't')
           sl=addwrap("(",(yyvsp[(1) - (4)].e)->sl,") <= ");
         else
           sl=addtxt((yyvsp[(1) - (4)].e)->sl," <= ");
         if((yyvsp[(4) - (4)].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[(4) - (4)].e)->sl,"}"));
         else if((yyvsp[(4) - (4)].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[(4) - (4)].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].e)->sl);
         free((yyvsp[(1) - (4)].e));
         free((yyvsp[(4) - (4)].e));
       ;}
    break;

  case 160:

/* Line 1464 of yacc.c  */
#line 2075 "vhd2vl.y"
    {
       slist *sl;
         if((yyvsp[(1) - (4)].e)->op == 'c')
           sl=addwrap("{",(yyvsp[(1) - (4)].e)->sl,"} != ");
         else if((yyvsp[(1) - (4)].e)->op != 't')
           sl=addwrap("(",(yyvsp[(1) - (4)].e)->sl,") != ");
         else
           sl=addtxt((yyvsp[(1) - (4)].e)->sl," != ");
         if((yyvsp[(4) - (4)].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[(4) - (4)].e)->sl,"}"));
         else if((yyvsp[(4) - (4)].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[(4) - (4)].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].e)->sl);
         free((yyvsp[(1) - (4)].e));
         free((yyvsp[(4) - (4)].e));
       ;}
    break;

  case 161:

/* Line 1464 of yacc.c  */
#line 2094 "vhd2vl.y"
    {
         expdata *e;
         e=xmalloc(sizeof(expdata));
         e->op='t'; /* Terminal symbol */
         e->sl=(yyvsp[(1) - (1)].ss)->sl;
         free((yyvsp[(1) - (1)].ss));
         (yyval.e)=e;
      ;}
    break;

  case 162:

/* Line 1464 of yacc.c  */
#line 2102 "vhd2vl.y"
    {
         expdata *e;
         e=xmalloc(sizeof(expdata));
         e->op='t'; /* Terminal symbol */
         e->sl=addvec(NULL,(yyvsp[(1) - (1)].txt));
         (yyval.e)=e;
      ;}
    break;

  case 163:

/* Line 1464 of yacc.c  */
#line 2109 "vhd2vl.y"
    {
         expdata *e;
         e=xmalloc(sizeof(expdata));
         e->op='n'; /* natural */
         e->value=(yyvsp[(1) - (1)].n);
         e->sl=addval(NULL,(yyvsp[(1) - (1)].n));
         (yyval.e)=e;
      ;}
    break;

  case 164:

/* Line 1464 of yacc.c  */
#line 2117 "vhd2vl.y"
    {
       (yyval.e)=addexpr((yyvsp[(1) - (3)].e),'+'," + ",(yyvsp[(3) - (3)].e));
      ;}
    break;

  case 165:

/* Line 1464 of yacc.c  */
#line 2120 "vhd2vl.y"
    {
       (yyval.e)=addexpr((yyvsp[(1) - (3)].e),'-'," - ",(yyvsp[(3) - (3)].e));
      ;}
    break;

  case 166:

/* Line 1464 of yacc.c  */
#line 2123 "vhd2vl.y"
    {
       (yyval.e)=addexpr((yyvsp[(1) - (3)].e),'*'," * ",(yyvsp[(3) - (3)].e));
      ;}
    break;

  case 167:

/* Line 1464 of yacc.c  */
#line 2126 "vhd2vl.y"
    {
       (yyval.e)=addexpr((yyvsp[(1) - (3)].e),'/'," / ",(yyvsp[(3) - (3)].e));
      ;}
    break;

  case 168:

/* Line 1464 of yacc.c  */
#line 2129 "vhd2vl.y"
    {
       /* one argument type conversion e.g. conv_integer(x) */
       expdata *e;
       e=xmalloc(sizeof(expdata));
       e->sl=addwrap("(",(yyvsp[(3) - (4)].e)->sl,")"); 
       (yyval.e)=e;
      ;}
    break;

  case 169:

/* Line 1464 of yacc.c  */
#line 2136 "vhd2vl.y"
    {
       expdata *e;
       e=xmalloc(sizeof(expdata));
       e->sl=addwrap("(",(yyvsp[(2) - (3)].e)->sl,")"); 
       (yyval.e)=e;
      ;}
    break;



/* Line 1464 of yacc.c  */
#line 4884 "vhd2vl.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1684 of yacc.c  */
#line 2144 "vhd2vl.y"


char *outfile;    /* Output file */
char *sourcefile; /* Input file */

int main(int argc, char *argv[]){
int i,j;
char *s;
slist *sl;
int status; 

  /* Init the indentation variables */
  indents[0]=NULL;
  for(i=1;i<MAXINDENT;i++){
    indents[i]=sl=xmalloc(sizeof(slist));
    sl->data.txt=s=xmalloc(sizeof(char) *((i<<1)+1));
    for(j=0;j<(i<<1);j++)
      *s++=' ';
    *s=0;
    sl->type=1;
    sl->slst=NULL;
  }

  if ((argc>=2) && strcmp(argv[1], "-d") == 0) {
    yydebug = 1;
    argv++;
    argc--;
  }

  if (argc>=2) {
     sourcefile = argv[1];
     if (strcmp(sourcefile,"-")!=0 && !freopen(sourcefile, "r", stdin)) {
        fprintf(stderr, "Error: Can't open input file '%s'\n", sourcefile);
        return(1);
     }
  } else {
     sourcefile = "-";
  }

  if (argc>=3) {
     outfile = argv[2];
     if (strcmp(outfile,"-")!=0 && !freopen(outfile, "w", stdout)) {
        fprintf(stderr, "Error: Can't open output file '%s'\n", outfile);
        return(1);
     }
  } else {
     outfile = "-";
  }

  printf("// File %s translated with vhd2vl v2.3 VHDL to Verilog RTL translator\n\n", sourcefile);
  fputs(
"// vhd2vl is Free (libre) Software:\n"
"//   Copyright (C) 2001 Vincenzo Liguori - Ocean Logic Pty Ltd\n"
"//     http://www.ocean-logic.com\n"
"//   Modifications Copyright (C) 2006 Mark Gonzales - PMC Sierra Inc\n"
"//   Modifications Copyright (C) 2002, 2005, 2008-2010 Larry Doolittle - LBNL\n"
"//     http://doolittle.icarus.com/~larry/vhd2vl/\n"
"//\n"
"//   vhd2vl comes with ABSOLUTELY NO WARRANTY.  Always check the resulting\n"
"//   Verilog for correctness, ideally with a formal verification tool.\n"
"//\n"
"//   You are welcome to redistribute vhd2vl under certain conditions.\n"
"//   See the license (GPLv2) file included with the source for details.\n\n"
"// The result of translation follows.  Its copyright status should be\n"
"// considered unchanged from the original VHDL.\n\n"
  , stdout);
  status = yyparse();
  fclose(stdout);
  fclose(stdin);
  if (status != 0 && strcmp(outfile,"-")!=0) unlink(outfile);
  return status;
}

